import processing.core.*; import processing.opengl.*; import java.applet.*; import java.awt.*; import java.awt.image.*; import java.awt.event.*; import java.io.*; import java.net.*; import java.text.*; import java.util.*; import java.util.zip.*; import javax.sound.midi.*; import javax.sound.midi.spi.*; import javax.sound.sampled.*; import javax.sound.sampled.spi.*; import java.util.regex.*; import javax.xml.parsers.*; import javax.xml.transform.*; import javax.xml.transform.dom.*; import javax.xml.transform.sax.*; import javax.xml.transform.stream.*; import org.xml.sax.*; import org.xml.sax.ext.*; import org.xml.sax.helpers.*; public class main extends PApplet {//*****************************************************************************
// TITLE:         Template 
// DESCRIPTION:   
// AUTHOR:        Prof Jarek Rossignac
// DATE CREATED:  October 2008
// EDITS:
//*****************************************************************************


boolean showHelpText=true;       // toggled by keys to show/hide help text
boolean printIt=false;           // temporarily set when key '?' is pressed and used to print some debugging values
int myWidth = 800;
int myHeight = 800;

public void setup() { 
  PFont font = loadFont("Courier-14.vlw"); textFont(font, 14);      // load font
  /*smooth();*/ /*strokeJoin(ROUND); strokeCap(ROUND);*/  rectMode(CENTER); // set up window and drawing modes
  frameRate(30);
  size(800, 800, OPENGL);
  setColors();
  myInit();  // initialize
  } 

public void draw() { background(121);  strokeWeight(1);                        // sets background
  if (showHelpText) showHelp(); else myActions(); 
  printIt=false;
  };  // end of draw

//***      KEY ACTIONS (details in keys tab)
public void keyPressed() { keys(); };
public void mousePressed() {
  if (!meshMode)
    myMousePressed();
  else {
    C.anchor(); C.pose();   if (keyPressed&&((key=='m')||(key=='w')) ) {C.setMark(); M.hitTriangle();};
  };   // record where the cursor was when the mouse was pressed
}
public void mouseReleased() {
  if (!meshMode)
    myMouseReleased();
  else {
    C.anchor(); C.pose();
  }  // reset the view if any key was pressed when mouse was released
}


//**************************************
// 3D CAMERA
// Written by Jarek Rossignac,  June 2006 
//*************************************
boolean jumps=false;
pt Origin=new pt(0,0,0);
pt Eye=new pt(0,0,800);
cam C = new cam(Eye, Origin);
cam C1 = new cam(Eye, Origin);
cam C2 = new cam(Eye, Origin);
float svd=800;
//float fov=atan2(width/2,svd);
float fov=PI/3;
pt mark = new pt(0,0,0);
pt eye = new pt(0,0,0);

pt Cbox = new pt(width/2,height/2,0);                   // mini-max box center
float Rbox=1000;                                        // Radius of enclosing ball

public void initView(Mesh M) { 
  M.computeBox(); 
  Cbox.setTo(M.Cbox); 
  Rbox=M.Rbox;
  M.r=PApplet.parseInt(9*Rbox/height); 
  C.F.setToPoint(Cbox); 
  C.D=Rbox*2; 
  C.U.setTo(0,1,0); 
  C.E.setToPoint(C.F); 
  C.E.addVec(new vec(0,0,1)); 
  C.pullE(); 
  C.pose();
}

class cam { 
  float D=10000, sD=D; 
  pt E = new pt(0,0,D); 
  pt sE = new pt(0,0,D);
  pt F = new pt(0,0,0); 
  pt sF = new pt(0,0,0); 
  vec U = new vec(0,1,0);
  vec I = new vec(1,0,0);  
  vec J = new vec(0,1,0); 
  vec K = new vec(0,0,1);
  int px=0, py=0;

  cam (pt pE, pt pF) {
    E.setToPoint(pE); 
    F.setToPoint(pF); 
    D=E.disTo(F);
  };

  public void apply() { 
    camera(E.x,E.y,E.z,F.x,F.y,F.z,U.x,U.y,U.z);  
  };

  public void setMark() {
    float x=PApplet.parseFloat(mouseX-width/2)*2/width; 
    float y=PApplet.parseFloat(mouseY-height/2)*2/height; 
    mark.setToPoint(F); 
    mark.addScaledVec(x*D,I); 
    mark.addScaledVec(y*D,J);
    eye.setToPoint(E);
  };

  public void write() {
    print("camera: ");     
    println("D="+D); 
    print("E="); 
    E.write(); 
    print("F="); 
    F.write(); 
    print("U="); 
    U.write(); 
    println();
  };

  public void anchor() {
    px=mouseX; 
    py=mouseY; 
    sE.setToPoint(E); 
    sF.setToPoint(F); 
    sD=D;
  };

  public void snap() {
    E.setToPoint(sE); 
    F.setToPoint(sF); 
    D=sD;
  };  
  public void snapD() {
    D=sD; 
    println(">> snapped D="+D); 
  };  

  public void pose() {
    vec nK=F.vecTo(E);  
    if (nK.norm()>0.0001f) {
      K.setToVec(nK);
    } 
    else {
      println("keep K");
    }; 
    K.makeUnit(); 
    vec nI=cross(U,K);  
    if (nI.norm()<0.0001f) {
      nI.setToVec(I); 
      println("I=UxJ");
    }; 
    nI.makeUnit();   
    I.setToVec(nI);
    J.setToVec(cross(K,I)); 
    J.makeUnit(); 
  }

  public void showPose() {
    vec II = I.make(); 
    II.mul(100); 
    stroke(250,20,20); 
    II.show(F); 
    vec JJ = U.make(); 
    JJ.mul(100); 
    stroke(0,200,50); 
    JJ.show(F); 
  }

  public void jump (Mesh M) {
    F.setToPoint(M.g()); 
    vec N = M.triNormal(); 
    N.makeUnit();
    E.setToPoint(M.triCenter()); 
    vec T = E.vecTo(F); 
    float nT=T.norm(); 
    E.addScaledVec(nT,N);  
//    U.setToVec(N);     U.back(); 
    sD=6*nT; 
    this.pullE(); 
    this.pose(); 
    //   println(); println("sD="+sD); this.write(); 
  };

  public void pullF() {
    float cD=F.disTo(E);  
    if (abs(cD)<0.001f) {
      F.setToPoint(E); 
      F.addScaledVec(D,K);
    } 
    else {
      F.moveTowards((cD-D)/cD,E);
    };
  };

  public void pullE() {
    float cD=F.disTo(E);  
    if (abs(cD)<0.001f) {
      E.setToPoint(F); 
      E.addScaledVec(D,K);
    } 
    else {
      E.moveTowards((cD-D)/cD,F);
    };
  };

  public void recomputeD() {
    D=E.disTo(F);
  };

  public void fly(float s) {
    float r=width*2; 
    float x=(mouseX-width/2)/r;   
    float y=(mouseY-height/2)/r; 
    F.addScaledVec(x,I); 
    F.addScaledVec(y,J); 
    F.addScaledVec(-s,K);
  };

  public void Turn() {
    float x=-(mouseX-width/2)*D/width/100;   
    float y=-(mouseY-height/2)*D/height/100; 
    F.addScaledVec(x,I); 
    F.addScaledVec(y,J); 
    if (cross(U,F.vecTo(E)).norm()<0.1f) { 
      F.addScaledVec(-x/10.0f,I); 
      F.addScaledVec(-y/10.0f,J); 
    };
  };

  public void turn() {
    float x=-(mouseX-px)*D/width; 
    float y=-(mouseY-py)*D/height; 
    F.setToPoint(sF); 
    F.addScaledVec(x,I); 
    F.addScaledVec(y,J);  
    if (cross(U,F.vecTo(E)).norm()<0.1f) { 
      F.addScaledVec(-x/10.0f,I); 
      F.addScaledVec(-y/10.0f,J); 
    };
  };

  public void Pan() {
    float r=16*width/D; 
    float x=-(mouseX-width/2)/r;   
    float y=-(mouseY-height/2)/r; 
    E.addScaledVec(x,I); 
    E.addScaledVec(y,J);   
    if (cross(U,F.vecTo(E)).norm()<0.1f) { 
      F.addScaledVec(-x/10.0f,I); 
      F.addScaledVec(-y/10.0f,J); 
    };
  };

  public void pan() {
    float r=width/D/2; 
    float x=-(mouseX-px)/r;   
    float y=-(mouseY-py)/r;     
    E.setToPoint(sE); 
    E.addScaledVec(x,I); 
    E.addScaledVec(y,J);  
    if (cross(U,F.vecTo(E)).norm()<0.1f) { 
      F.addScaledVec(-x/10.0f,I); 
      F.addScaledVec(-y/10.0f,J); 
    };
  };

  public void zoom() {
    float r=width/M.Rbox/2; 
    float x=-(mouseX-px)/r;   
    float y=-(mouseY-py)/r; 
    //   E.setToPoint(sE); E.addScaledVec(x,I); 
    D=sD+y; 
  };

  public void track (cam K) {
    float s=0.0005f*M.nt; 
    if (s<0.05f) {
      s=0.05f;
    }; 
    if (s>0.25f) {
      s=0.25f;
    }; 
    E.moveTowards(s,K.E); 
    F.moveTowards(s,K.F); 
    this.recomputeD(); 
    U.addScaled(s,K.U);    U.makeUnit(); 
    this.pose(); 
    this.anchor();
  }
  public void setToCam (cam K) {
    E.setToPoint(K.E); 
    F.setToPoint(K.F); 
    this.recomputeD(); 
    U.setToVec(K.U);  U.makeUnit(); 
    this.pose(); 
    this.anchor();
  }
}  // end calss cam
int red, yellow, green, cyan, blue, magenta, dred, dyellow, dgreen, dcyan, dblue, dmagenta, white, black, orange, grey, metal;  // declares color names
public void setColors() {
  colorMode(HSB,121);
  red = color(0, 120, 120); yellow = color(20, 120, 120); green = color(40, 120, 120); cyan = color(60, 120, 120); blue = color(80, 120, 120); magenta = color(100, 120, 120); 
  dred = color(0, 120, 60); dyellow = color(20, 120, 60); dgreen = color(40, 120, 60); dcyan = color(60, 120, 60); dblue = color(80, 120, 60); dmagenta = color(100, 120, 60); 
  white = color(0, 0, 120); black = color(0, 120,0); grey = color(0, 0,60); orange = color(10, 100, 120); metal = color(70, 60, 100); };
public int ramp(int c, int m) {float f=90.f*c/m; return color(PApplet.parseInt(f/3),30+f,30+f);}
public void showColors() {
   noStroke();
   pt q=new pt(0,0,0); translate(30,height-50); 
   pushMatrix();
   fill(red); q.show(10); translate(20,0);
   fill(yellow); q.show(10); translate(20,0);
   fill(green); q.show(10); translate(20,0);
   fill(cyan); q.show(10); translate(20,0);
   fill(blue); q.show(10); translate(20,0);
   fill(magenta); q.show(10); translate(20,0);
   fill(grey); q.show(10); translate(20,0);
   popMatrix();
   translate(0,20);
   pushMatrix();
   fill(dred); q.show(10); translate(20,0);
   fill(dyellow); q.show(10); translate(20,0);
   fill(dgreen); q.show(10); translate(20,0);
   fill(dcyan); q.show(10); translate(20,0);
   fill(dblue); q.show(10); translate(20,0);
   fill(dmagenta); q.show(10); translate(20,0);
   fill(black); q.show(10); translate(20,0);
   popMatrix();
   }

class Colors {
  int c=0; 
  int nc=10;
  Colors (){};
  Colors (int n){nc=n;};
  public void total(int n) {nc=n; }
  public void reset() {c=nc-1; }
  public int next() {c=(c+1)%nc; return color(255.f*c/nc,255.f-255.f*c/nc,127); }
}

/*
color red = color(255,0,0), yellow= color(255,255,0), green= color(0,255,0), cyan= color(0,255,255), blue= color(0,0,255), magenta= color(255,0,255), 
        dred = color(125,0,0), dyellow= color(125,125,0), dgreen= color(0,125,0), dcyan= color(0,125,125), dblue= color(0,0,125), dmagenta= color(125,0,125), 
         grey =color(200,200,200), black=color(0,0,0);
*/

int pic=0; // picture number for saving movies
public void picture() {String S="data/P/f"+Format0(pic++,3)+".tif"; saveFrame(S); }
int fn=0;    // number of the file last read

public String  Format0(int v, int n) {String s=str(v); String spaces = "00000000000000000000000000";
   int L = max(0,n-s.length());
   String front = spaces.substring(0, L);
   return(front+s);
  };
//*************************************************************
//**** 2D GEOMETRY CLASSES AND UTILITIES, Jarek Rossignac *****
//****            REVISED October 3, 2008                 *****
//*************************************************************

// Transforms the local CS
public void push2D() {pushMatrix();}                           // saves current LCS (local coordinate system) by pushing matrix stack
public void tra2D(vec2D V) {translate(V.x,V.y);}                 // translates view by vector V
public void tra2D(pt2D P) {translate(P.x,P.y);}                  // translates view from origin to P
public void traRev2D(pt2D P) {translate(-P.x,-P.y);}             // translates view back by vector from P to origin
public void rot2D(float a) {rotate(a);}                        // rotates view around origin by angle a
public void rot2D(float a, pt2D P) {tra2D(P); rot2D(a); traRev2D(P);}  // rotates view by a around point P
public void sca2D(float s) {scale(s);}                         // scales view wrt origin
public void sca2D(float s, pt2D P) {tra2D(P); sca2D(s); traRev2D(P);}  // scales view wrt point P
public void pop2D() {popMatrix();}                             // restores previously saved CS by popping stack
// screen and mouse
public pt2D screenCenter2D() {return(new pt2D(height/2,height/2));}                                           // returns point at center of screen
public boolean mouseIsInWindow2D() {return(((mouseX>0)&&(mouseX<height)&&(mouseY>0)&&(mouseY<height)));}; // returns true if mouse is in window
public pt2D Mouse2D() {return(new pt2D(mouseX,mouseY));};                                                     // returns point with current mouse location
public pt2D pMouse2D() {return(new pt2D(pmouseX,pmouseY));};                                                  // returns point with previous mouse location
public vec2D MouseDrag2D() {return new vec2D(mouseX-pmouseX,mouseY-pmouseY);};                                // vector representing recent mouse displacement
public float angleTracedWithMouse2D () {vec2D V1=U2D(screenCenter2D(),pMouse2D()); vec2D V2=U2D(screenCenter2D(),Mouse2D()); return a2D(V1,V2);}
public float scaleTracedWithMouse2D () {float d1=d2D(screenCenter2D(),pMouse2D()); float d2=d2D(screenCenter2D(),Mouse2D()); return d2/d1;}
// Make points
public pt2D P2D(float x, float y) {return new pt2D(x,y); };                                                       // make point (x,y)
public pt2D P2D() {return P2D(0,0); };                                                                            // make point (0,0)
public pt2D P2D(pt2D P) {return P2D(P.x,P.y); };                                                                    // make copy of point P
// Weighted combinations of points
public pt2D A2D(pt2D A, pt2D B) {return P2D((A.x+B.x)/2.0f,(A.y+B.y)/2.0f); };                                          // Average: (A+B)/2
public pt2D A2D(pt2D A, pt2D B, pt2D C) {return P2D((A.x+B.x+C.x)/3.0f,(A.y+B.y+C.y)/3.0f); };                            // Average: (A+B+C)/3
public pt2D L2D(pt2D A, float s, pt2D B) {return P2D(A.x+s*(B.x-A.x),A.y+s*(B.y-A.y)); };                             // Linear interpolation: A+sAB
public pt2D S2D(float a, pt2D A, float b, pt2D B){return P2D(a*A.x+b*B.x,a*A.y+b*B.y); }                                                         // Weighted sum: aA+bB, make sure that a+b=1
public pt2D S2D(float a, pt2D A, float b, pt2D B, float c, pt2D C){return P2D(a*A.x+b*B.x+c*C.x,a*A.y+b*B.y+c*C.y); }                              // Weighted sum: aA+bB+cC, make sure that a+b+c=1
public pt2D S2D(float a, pt2D A, float b, pt2D B, float c, pt2D C, float d, pt2D D){return P2D(a*A.x+b*B.x+c*C.x+d*D.x,a*A.y+b*B.y+c*C.y+d*D.y); }   // Weighted sum: aA+bB+cC+dD, make sure that a+b+c+d=1
// transformed points
public pt2D T2D(pt2D P, vec2D V) {return P2D(P.x + V.x, P.y + V.y); }                                                 // P+V (transaltes P by displacement vector V
public pt2D T2D(pt2D P, float s, vec2D V) {return T2D(P,S2D(s,V)); }                                                    // P+sV (transaltes P by a fraction s of displacement vector V
public pt2D T2D(pt2D P, float s, pt2D Q) {return T2D(P,s,V2D(P,Q)); }                                                   // P+sPQ/||PQ|| transaltes P by a fraction s of PQ (towards Q)
public pt2D T2D(pt2D O, float x, vec2D I, float y, vec2D J) {return P2D(O.x + x*I.x+ y*J.x, O.y + x*I.y+ y*J.y); }      // O+xI+yJ  (change of coordinate systems)
public pt2D R2D(pt2D Q, float a) {float c=cos(a), s=sin(a); return P2D(c*Q.x-s*Q.y, s*Q.x+c*Q.y); }                 // Rotated Q by a around origin
public pt2D R2D(pt2D Q, float a, pt2D P) {return T2D(P,R2D(V2D(P,Q),a)); }                                                // Rotated Q by a around P
// distance
public float d2D(pt2D P, pt2D Q) {return n2D(V2D(P,Q));};                                                // ||AB||
public float d22D(pt2D P, pt2D Q) {return n22D(V2D(P,Q));};                                              // ||AB||^2
// Make vectors
public vec2D V2D(float x, float y) {return new vec2D(x,y); };                                     // make V(x,y)
public vec2D V2D() {return V2D(0,0);}                                                             // V(0,0)
public vec2D V2D(vec2D V) {return new vec2D(V.x,V.y); };                                            // make copy of V
public vec2D V2D(pt2D P, pt2D Q) {return new vec2D(Q.x-P.x,Q.y-P.y);};                                // PQ (vector from P to Q)
// scale, and combine vectors
public vec2D S2D(float s,vec2D V) {return V2D(s*V.x,s*V.y);};                                                                                        // sV
public vec2D S2D(vec2D U, vec2D V) {return V2D(U.x+V.x,U.y+V.y); };                                                                                    // U+V
public vec2D S2D(float a, vec2D A, float b, vec2D B){return V2D(a*A.x+b*B.x,a*A.y+b*B.y); }                                                            // Weighted sum: aA+bB
public vec2D S2D(float a, vec2D A, float b, vec2D B, float c, vec2D C){return V2D(a*A.x+b*B.x+c*C.x,a*A.y+b*B.y+c*C.y); }                                // Weighted sum: aA+bB+cC
public vec2D S2D(float a, vec2D A, float b, vec2D B, float c, vec2D C, float d, vec2D D){return V2D(a*A.x+b*B.x+c*C.x+d*D.x,a*A.y+b*B.y+c*C.y+d*D.y); }    // Weighted sum: aA+bB+cC+dD
public vec2D L2D(vec2D U,float s,vec2D V) {return V2D(U.x+s*(V.x-U.x),U.y+s*(V.y-U.y));};                                                              // (1-s)U+sV
public vec2D A2D(vec2D U, vec2D V) {return L2D(U,0.5f,V); };                                                                                            // (U+V)/2
// dot product, norm, normalization
public float dot2D(vec2D U, vec2D V) {return U.x*V.x+U.y*V.y; };                                     // U*V  (dot product)
public float n22D(vec2D V) {return sq(V.x)+sq(V.y);};                                              // V*V  (V^2)
public float n2D(vec2D V) {return sqrt(n22D(V));};                                                   // ||V||
public vec2D U2D(vec2D V) {float n = n2D(V); if (n==0) return null; else return S2D(1/n,V);};            // V/||V||  (normalized V, unit vector)
public vec2D U2D(pt2D Q, pt2D P) {return U2D(V2D(Q,P)); };                                                 // Unit PQ
// angles and rotations
public float a2D (vec2D U, vec2D V) {float a = atan2(dot2D(R2D(U),V),dot2D(U,V)); if(a>PI) return mPItoPIangle2D(a-2*PI); if(a<-PI) return mPItoPIangle2D(a+2*PI); return a; };  // angle(U,V) between -PI and PI
public vec2D R2D(vec2D V) {return V2D(-V.y,V.x);};                                                         // V rotated 90 degrees (clockwise as seen on screen)
public vec2D R2D(pt2D Q, pt2D P) {return R2D(V2D(Q,P)); };                                                     // vector QP rotated 90 degrees
public vec2D R2D(vec2D U, float a) {float c=cos(a), s=sin(a); return V2D(c*U.x-s*U.y, s*U.x+c*U.y); };     // U rotated by a
public vec2D R2D(vec2D U, float t, vec2D V) {return S2D(1+t*(n2D(V)-n2D(U))/n2D(U),R2D(U,t*angle2D(U,V)));  };         // interpolation (angle and length) between U and V
// three points
public float a2D(pt2D A, pt2D B, pt2D C) {return  a2D(V2D(B,A),V2D(B,C)); }                                 // angle (BA,BC)
public float turnAngle2D(pt2D A, pt2D B, pt2D C) {return  a2D(V2D(A,B),V2D(B,C)); }                         // angle (AB,BC)
public boolean isRightTurn2D(pt2D A, pt2D B, pt2D C) {return dot2D( R2D(A,B),V2D(B,C)) > 0 ; };             // right turn (as seen on screen)
public boolean isRightOf2D(pt2D A, pt2D Q, vec2D T) {return dot2D(R2D(T),V2D(Q,A)) > 0 ; };                 // A is on right of ray(Q,T) (as seen on screen)
public boolean isInFrontOf2D(pt2D A, pt2D Q, vec2D T) {return dot2D(T,V2D(Q,A)) > 0 ; };                  // A is in frontof ray(Q,T) 
// display
public void v2D(pt2D P) {vertex(P.x,P.y);};                                                     // next point when drawing polygons between beginShape(); and endShape();
public void showCross2D(pt2D P, float r) {line(P.x-r,P.y,P.x+r,P.y); line(P.x,P.y-r,P.x,P.y+r);};   // shows P as cross of length r
public void showCross2D(pt2D P) {showCross2D(P,2);};                                                      // shows P as small cross
public void show2D(pt2D P, float r) {ellipse(P.x, P.y, 2*r, 2*r);};                             // draws circle of center r around point
public void show2D(pt2D P) {ellipse(P.x, P.y, 4,4);};                                           // draws small circle around point
public void show2D(pt2D P, pt2D Q) {line(P.x,P.y,Q.x,Q.y); };                                     // draws edge (P,Q)
public void show2D(pt2D P, vec2D V) {line(P.x,P.y,P.x+V.x,P.y+V.y); }                             // show line from P along V
public void show2D(pt2D P, float s, vec2D V) {show2D(P,S2D(s,V));}                                    // show line from P along sV
public void arrow2D(pt2D P, pt2D Q) {arrow2D(P,V2D(P,Q)); }                                           // draws arrow from P to Q
public void arrow2D(pt2D P, float s, vec2D V) {arrow2D(P,S2D(s,V));}                                   // show arrow from P along sV
public void arrow2D(pt2D P, vec2D V) {show2D(P,V);  float n=n2D(V); float s=max(min(0.2f,20.f/n),6.f/n);  // show arrow from P along V
  pt2D Q=T2D(P,V); vec2D U = S2D(-s,V); vec2D W = R2D(S2D(.3f,U)); beginShape(); v2D(T2D(T2D(Q,U),W)); v2D(Q); v2D(T2D(T2D(Q,U),-1,W)); endShape(CLOSE);}; 

//************************************************************************
//**** ANGLES
//************************************************************************
public float angle2D(vec2D V) {return(atan2(V.y,V.x)); };
public float angle2D(vec2D U, vec2D V) {return(atan2(dot2D(R2D(U),V),dot2D(U,V))); };
public float mPItoPIangle2D(float a) { if(a>PI) return(mPItoPIangle2D(a-2*PI)); if(a<-PI) return(mPItoPIangle2D(a+2*PI)); return(a);};
public float toDeg2D(float a) {return(a*180/PI);}
public float toRad2D(float a) {return(a*PI/180);}
//************************************************************************
//**** POINTS
//************************************************************************
class pt2D { float x=0,y=0; 
  // CREATE
  pt2D () {}
  pt2D (float px, float py) {x = px; y = py;};
  pt2D (pt2D P) {x = P.x; y = P.y;};
  pt2D (pt2D P, vec2D V) {x = P.x+V.x; y = P.y+V.y;};
  pt2D (pt2D P, float s, vec2D V) {x = P.x+s*V.x; y = P.y+s*V.y;};
  pt2D (pt2D A, float s, pt2D B) {x = A.x+s*(B.x-A.x); y = A.y+s*(B.y-A.y);};

  // MODIFY
  public void setTo(float px, float py) {x = px; y = py;};  
  public void setTo(pt2D P) {x = P.x; y = P.y;}; 
  public void setToMouse() { x = mouseX; y = mouseY; }; 
  public void trackMouse() { x += mouseX-pmouseX; y += mouseY-pmouseY; }; 
  public void translateToTrack(float s, pt2D P) {setTo(T2D(P,s,V2D(P,this)));};
  public void track(float s, pt2D P) {setTo(T2D(P,s,V2D(P,this)));};
  public pt2D scaleBy(float f) {x*=f; y*=f; return this;};
  public void scaleBy(float u, float v) {x*=u; y*=v;};
  public void add(vec2D V) {x += V.x; y += V.y;};   
  public void add(float s, vec2D V) {x += s*V.x; y += s*V.y;};   
  public void translateBy(vec2D V) {x += V.x; y += V.y;};   
  public void translateBy(float s, vec2D V) {x += s*V.x; y += s*V.y;};   
  public void translateBy(float u, float v) {x += u; y += v;};
  public void translateTowards(float s, pt2D P) {x+=s*(P.x-x);  y+=s*(P.y-y); };
  public void translateTowardsBy(float s, pt2D P) {vec2D V = this.makeVecTo(P); V.normalize(); this.translateBy(s,V); };
  public void addPt(pt2D P) {x += P.x; y += P.y;};        // incorrect notation, but useful for computing weighted averages
  public void addScaledPt(float s, pt2D P) {x += s*P.x; y += s*P.y;};        // incorrect notation, but useful for computing weighted averages
  public void rotateBy(float a) {float dx=x, dy=y, c=cos(a), s=sin(a); x=c*dx-s*dy; y=+s*dx+c*dy; };     // around origin
  public void rotateBy(float a, pt2D P) {float dx=x-P.x, dy=y-P.y, c=cos(a), s=sin(a); x=P.x+c*dx-s*dy; y=P.y+s*dx+c*dy; };   // around point P
  public void rotateBy(float s, float t, pt2D P) {float dx=x-P.x, dy=y-P.y; dx-=dy*t; dy+=dx*s; dx-=dy*t; x=P.x+dx; y=P.y+dy; };   // s=sin(a); t=tan(a/2);
  public void clipToWindow() {x=max(x,0); y=max(y,0); x=min(x,height); y=min(y,height); }
  
  // OUTPUT POINT
  public pt2D clone() {return new pt2D(x,y); };
  public pt2D makeClone() {return new pt2D(x,y); };
  public pt2D makeTranslatedBy(vec2D V) {return(new pt2D(x + V.x, y + V.y));};
  public pt2D makeTranslatedBy(float s, vec2D V) {return(new pt2D(x + s*V.x, y + s*V.y));};
  public pt2D makeTransaltedTowards(float s, pt2D P) {return(new pt2D(x + s*(P.x-x), y + s*(P.y-y)));};
  public pt2D makeTranslatedBy(float u, float v) {return(new pt2D(x + u, y + v));};
  public pt2D makeRotatedBy(float a, pt2D P) {float dx=x-P.x, dy=y-P.y, c=cos(a), s=sin(a); return(new pt2D(P.x+c*dx-s*dy, P.y+s*dx+c*dy)); };
  public pt2D makeRotatedBy(float a) {float dx=x, dy=y, c=cos(a), s=sin(a); return(new pt2D(c*dx-s*dy, s*dx+c*dy)); };
  public pt2D makeProjectionOnLine(pt2D P, pt2D Q) {float a=dot2D(P.makeVecTo(this),P.makeVecTo(Q)), b=dot2D(P.makeVecTo(Q),P.makeVecTo(Q)); return(P.makeTransaltedTowards(a/b,Q)); };
  public pt2D makeOffset(pt2D P, pt2D Q, float r) {
    float a = angle2D(vecTo(P),vecTo(Q))/2;
    float h = r/tan(a); 
    vec2D T = vecTo(P); T.normalize(); vec2D N = T.left();
    pt2D R = new pt2D(x,y); R.translateBy(h,T); R.translateBy(r,N);
    return R; };

   // OUTPUT VEC
  public vec2D vecTo(pt2D P) {return(new vec2D(P.x-x,P.y-y)); };
  public vec2D makeVecTo(pt2D P) {return(new vec2D(P.x-x,P.y-y)); };
  public vec2D makeVecToCenter () {return(new vec2D(x-height/2.f,y-height/2.f)); };
  public vec2D makeVecToAverage (pt2D P, pt2D Q) {return(new vec2D((P.x+Q.x)/2.0f-x,(P.y+Q.y)/2.0f-y)); };
  public vec2D makeVecToAverage (pt2D P, pt2D Q, pt2D R) {return(new vec2D((P.x+Q.x+R.x)/3.0f-x,(P.y+Q.y+R.x)/3.0f-y)); };
  public vec2D makeVecToMouse () {return(new vec2D(mouseX-x,mouseY-y)); };
  public vec2D makeVecToBisectProjection (pt2D P, pt2D Q) {float a=disTo(P), b=disTo(Q);  return makeVecTo(L2D(P,a/(a+b),Q)); };
  public vec2D makeVecToNormalProjection (pt2D P, pt2D Q) {float a=dot2D(V2D(P,this),V2D(P,Q)), b=d22D(P,Q); return V2D(this,L2D(P,a/b,Q)); };
 // vec makeVecTowards(pt P, float d) {vec V = makeVecTo(P); float n = V.norm(); V.normalize(); V.scaleBy(d-n); return V; };
 
  // OUTPUT TEST OR MEASURE
  public float disTo(pt2D P) {return(sqrt(sq(P.x-x)+sq(P.y-y))); };
  public float disToMouse() {return(sqrt(sq(x-mouseX)+sq(y-mouseY))); };
  public boolean isInWindow() {return(((x>0)&&(x<height)&&(y>0)&&(y<height)));};
  public boolean projectsBetween(pt2D P, pt2D Q) {float a=dot2D(P.makeVecTo(this),P.makeVecTo(Q)), b=dot2D(P.makeVecTo(Q),P.makeVecTo(Q)); return((0<a)&&(a<b)); };
  public float ratioOfProjectionBetween(pt2D P, pt2D Q) {float a=dot2D(P.makeVecTo(this),P.makeVecTo(Q)), b=dot2D(P.makeVecTo(Q),P.makeVecTo(Q)); return(a/b); };
  public float disToLine(pt2D P, pt2D Q) {float a=dot2D(P.makeVecTo(this),P.makeVecTo(Q).makeUnit().makeTurnedLeft()); return(abs(a)); };
  public boolean isLeftOf(pt2D P, pt2D Q) {boolean l=dot2D(P.makeVecTo(this),P.makeVecTo(Q).makeTurnedLeft())>0; return(l);  };
  public boolean isInTriangle(pt2D A, pt2D B, pt2D C) { boolean a = this.isLeftOf(B,C); boolean b = this.isLeftOf(C,A); boolean c = this.isLeftOf(A,B); return((a&&b&&c)||(!a&&!b&&!c));};
  public boolean isInCircle(pt2D C, float r) {return d2D(this,C)<r; }  // returns true if point is in circle C,r
  public float triArea(pt2D P, pt2D Q) {float a=dot2D(P.makeVecTo(this),P.makeVecTo(Q).makeTurnedLeft()); return(a/2.f); };

  
  // DRAW , PRINT
  public void show() {ellipse(x, y, height/200, height/200); }; // shows point as small dot
  public void show(float r) {ellipse(x, y, 2*r, 2*r); }; // shows point as disk of radius r
  public void showCross(float r) {line(x-r,y,x+r,y); line(x,y-r,x,y+r);}; 
  public void v() {vertex(x,y);};  // used for drawing polygons between beginShape(); and endShape();
  public void write() {println("("+x+","+y+")");};  // writes point coordinates in text window
  public void showLabel(String s, vec2D D) {text(s, x+D.x,y+D.y);  };  // show string displaced by vector D from point
  public void showLabel(String s) {text(s, x+5,y+4);  };
  public void showLabel(int i) {text(str(i), x+5,y+4);  };  // shows integer number next to point
  public void showLabel(String s, float u, float v) {text(s, x+u, y+v);  };
  public void showSegmentTo (pt2D P) {line(x,y,P.x,P.y); }; // draws edge to another point
  public void to (pt2D P) {line(x,y,P.x,P.y); }; // draws edge to another point

  } // end of pt class


//NEW CODE: Calculating barycentre of triangle (n-point) using code from triangles demo applet.
//for two points:
public pt2D weightedSum(float a, pt2D A, float b, pt2D B) {pt2D P =  A.makeClone(); P.scaleBy(a); P.addScaledPt(b,B); return(P);}

//for three points:
public pt2D weightedSum(float a, pt2D A, float b, pt2D B, float c, pt2D C) {pt2D P =  A.makeClone(); P.scaleBy(a); P.addScaledPt(b,B);  P.addScaledPt(c,C); return(P);}

//for four points:
public pt2D weightedSum(float a, pt2D A, float b, pt2D B, float c, pt2D C, float d, pt2D D) 
        {pt2D P =  A.makeClone(); P.scaleBy(a); P.addScaledPt(b,B); P.addScaledPt(c,C); P.addScaledPt(d,D); return(P);}




//************************************************************************
//**** VECTORS
//************************************************************************
class vec2D { float x=0,y=0; 
 // CREATE
  vec2D () {};
  vec2D (vec2D V) {x = V.x; y = V.y;};
  vec2D (float s, vec2D V) {x = s*V.x; y = s*V.y;};
  vec2D (float px, float py) {x = px; y = py;};
  vec2D (pt2D P, pt2D Q) {x = Q.x-P.x; y = Q.y-P.y;};
 
 // MODIFY
  public void setTo(float px, float py) {x = px; y = py;}; 
  public void setTo(pt2D P, pt2D Q) {x = Q.x-P.x; y = Q.y-P.y;}; 
  public void setTo(vec2D V) {x = V.x; y = V.y;}; 
  public void scaleBy(float f) {x*=f; y*=f;};
  public void back() {x=-x; y=-y;};
  public void mul(float f) {x*=f; y*=f;};
  public void div(float f) {x/=f; y/=f;};
  public void scaleBy(float u, float v) {x*=u; y*=v;};
  public void normalize() {float n=sqrt(sq(x)+sq(y)); if (n>0.000001f) {x/=n; y/=n;};};
  public void add(vec2D V) {x += V.x; y += V.y;};   
  public void add(float s, vec2D V) {x += s*V.x; y += s*V.y;};   
  public void add(float u, float v) {x += u; y += v;};
  public void turnLeft() {float w=x; x=-y; y=w;};
  public void rotateBy (float a) {float xx=x, yy=y; x=xx*cos(a)-yy*sin(a); y=xx*sin(a)+yy*cos(a); };
  
  // OUTPUT VEC
  public vec2D makeClone() {return(new vec2D(x,y));}; 
  public vec2D makeUnit() {float n=sqrt(sq(x)+sq(y)); if (n<0.000001f) n=1; return(new vec2D(x/n,y/n));}; 
  public vec2D unit() {float n=sqrt(sq(x)+sq(y)); if (n<0.000001f) n=1; return(new vec2D(x/n,y/n));}; 
  public vec2D makeScaledBy(float s) {return(new vec2D(x*s, y*s));};
  public vec2D makeTurnedLeft() {return(new vec2D(-y,x));};
  public vec2D left() {return(new vec2D(-y,x));};
  public vec2D makeOffsetVec(vec2D V) {return(new vec2D(x + V.x, y + V.y));};
  public vec2D makeOffsetVec(float s, vec2D V) {return(new vec2D(x + s*V.x, y + s*V.y));};
  public vec2D makeOffsetVec(float u, float v) {return(new vec2D(x + u, y + v));};
  public vec2D makeRotatedBy(float a) {return(new vec2D(x*cos(a)-y*sin(a),x*sin(a)+y*cos(a))); };
  public vec2D makeReflectedVec(vec2D N) { return makeOffsetVec(-2.f*dot2D(this,N),N);};

  // OUTPUT TEST MEASURE
  public float norm() {return(sqrt(sq(x)+sq(y)));}
  public boolean isNull() {return((abs(x)+abs(y)<0.000001f));}
  public float angle() {return(atan2(y,x)); }

  // DRAW, PRINT
  public void write() {println("("+x+","+y+")");};
  public void show (pt2D P) {line(P.x,P.y,P.x+x,P.y+y); }; 
  public void showAt (pt2D P) {line(P.x,P.y,P.x+x,P.y+y); }; 
  public void showArrowAt (pt2D P) {line(P.x,P.y,P.x+x,P.y+y); 
      float n=min(this.norm()/10.f,height/50.f); 
      pt2D Q=P.makeTranslatedBy(this); 
      vec2D U = this.makeUnit().makeScaledBy(-n);
      vec2D W = U.makeTurnedLeft().makeScaledBy(0.3f);
      beginShape(); Q.makeTranslatedBy(U).makeTranslatedBy(W).v(); Q.v(); 
                    W.scaleBy(-1); Q.makeTranslatedBy(U).makeTranslatedBy(W).v(); endShape(CLOSE); }; 
  public void showLabel(String s, pt2D P) {pt2D Q = P.makeTranslatedBy(0.5f,this); 
           vec2D N = makeUnit().makeTurnedLeft(); Q.makeTranslatedBy(3,N).showLabel(s); };
  } // end vec class
 
 
 // fitting
 public vec2D proVec2D (pt2D B, pt2D C, pt2D D) { return L2D(V2D(C,B), d2D(C,B)/(d2D(C,B)+d2D(C,D)),V2D(C,D)); }
 public vec2D vecToCubic2D (pt2D A, pt2D B, pt2D C, pt2D D, pt2D E) {return V2D( (-A.x+4*B.x-6*C.x+4*D.x-E.x)/6, (-A.y+4*B.y-6*C.y+4*D.y-E.y)/6  );}
// CURVES
public void drawCubicBezier2D(pt2D A, pt2D B, pt2D C, pt2D D) {bezier(A.x,A.y,B.x,B.y,C.x,C.y,D.x,D.y);}
public pt2D B2D(pt2D A, pt2D B, pt2D C, float s) {return( L2D(L2D(B,s/4.f,A),0.5f,L2D(B,s/4.f,C))); };                            // returns a tucked B towards its neighbors
public pt2D F2D(pt2D A, pt2D B, pt2D C, pt2D D, float s) {return( L2D(L2D(A,1.f+(1.f-s)/8.f,B) ,0.5f, L2D(D,1.f+(1.f-s)/8.f,C))); };    // returns a bulged mid-edge point 
public pt2D limit2D(pt2D A, pt2D B, pt2D C, pt2D D, pt2D E, float s, int r) {
  if (r==0) return C.clone();
  else return limit2D(B2D(A,B,C,s),F2D(A,B,C,D,s),B2D(B,C,D,s),F2D(B,C,D,E,s),B2D(C,D,E,s),s,r-1);
  }
  
public boolean edgesCross(pt2D A, pt2D B, pt2D C, pt2D D) {return (dot2D(U2D(R2D(V2D(A,B))),V2D(A,C))>0 != dot2D(U2D(R2D(V2D(A,B))),V2D(A,D))>0) // tests whether two edges cross
                                                && (dot2D(U2D(R2D(V2D(C,D))),V2D(C,A))>0 != dot2D(U2D(R2D(V2D(C,D))),V2D(C,B))>0) ; }

  
//************************************************************************
//**** CIRCLES
//************************************************************************
public pt circumCenter (pt A3, pt B3, pt C3) {    // computes the center of a circumscirbing circle to triangle (A,B,C)
  pt2D A = new pt2D(A3.x,A3.y);
  pt2D B = new pt2D(B3.x,B3.y);
  pt2D C = new pt2D(C3.x,C3.y);
  vec2D AB =  A.makeVecTo(B);  float ab2 = dot2D(AB,AB);
  vec2D AC =  A.makeVecTo(C); AC.turnLeft();  float ac2 = dot2D(AC,AC);
  float d = 2*dot2D(AB,AC);
  AB.turnLeft();
  AB.scaleBy(-ac2); 
  AC.scaleBy(ab2);
  AB.add(AC);
  AB.scaleBy(1.f/d);
  pt2D X =  A.makeClone();
  X.translateBy(AB);
  return(new pt(X.x, X.y, 0));//returns a 3D point, but ignores the Z
  };

public boolean ccw(pt A3, pt B3, pt C3) {
  pt2D A = new pt2D(A3.x,A3.y);
  pt2D B = new pt2D(B3.x,B3.y);
  pt2D C = new pt2D(C3.x,C3.y);
  return C.isLeftOf(A,B) ;
}

//**************************************
// 3D POINTS AND VECTOR CLASSES
// Written by Jarek Rossignac,  June 2006
//*************************************

// ******************************************************************************************** SHORT CUTS 
// ===== make
public pt P(float x, float y, float z) {return new pt(x,y,z); };                            // make point (x,y,z)
public vec V(float x, float y, float z) {return new vec(x,y,z); };                          // make vector (x,y,z)
public pt P(pt P) {return new pt(P.x,P.y,P.z); };                                           // make copy of point
public vec V(vec V) {return new vec(V.x,V.y,V.z); };                                        // make copy of vector V
public vec V(pt P, pt Q) {return new vec(Q.x-P.x,Q.y-P.y,Q.z-P.z);};                        // PQ
public vec N(pt A, pt B, pt C) {return C(V(A,B),V(A,C)); };                             // normal to triangle (not unit)

// ===== add, scale, normalize, combine
public pt A(pt A, pt B) {return new pt(A.x+B.x,A.y+B.y,A.z+B.z); };                                    // A+B
public pt A(pt A, float s, pt B) {return new pt(A.x+s*B.x,A.y+s*B.y,A.z+s*B.z); };                     // A+sB
public pt S(float s, pt A) {return new pt(s*A.x,s*A.y,s*A.z); };                                       // sA
public vec U(vec V) {float n = n(V); if (n==0) return V(0,0,0); else return V(V.x/n,V.y/n,V.z/n);};    // V/||V||
public vec S(float s,vec V) {return new vec(s*V.x,s*V.y,s*V.z);};                                      // sV

// ===== (weighted) average
public pt M(pt A, pt B) {return P((A.x+B.x)/2.0f,(A.y+B.y)/2.0f,(A.z+B.z)/2.0f); }                             // (A+B)/2
public pt M(pt A, pt B, pt C) {return new pt((A.x+B.x+C.x)/3.0f,(A.y+B.y+C.y)/3.0f,(A.z+B.z+C.z)/3.0f); };      // (A+B+C)/3
public pt M(float a, pt A, float b, pt B) {return A(S(a,A),b,B);}                                            // aA+bB 
public pt M(float a, pt A, float b, pt B, float c, pt C) {return A(S(a,A),M(b,B,c,C));}                      // aA+bB+cC 
public pt M(float a, pt A, float b, pt B, float c, pt C, float d, pt D){return A(M(a,A,b,B),M(c,C,d,D));}    // aA+bB+cC+dD
public vec M(vec U, vec V) {return new vec((U.x+V.x)/2.0f,(U.y+V.y)/2.0f,(U.z+V.z)/2.0f); };                    // (U+V)/2
public vec M(float a, vec U, float b, vec V) {return new vec(a*U.x+b*V.x,a*U.y+b*V.y,a*U.z+b*V.z);}          // aU+bV 

// ===== interpolate
public pt S(pt A, float s, pt B) {return new pt(A.x+s*(B.x-A.x),A.y+s*(B.y-A.y),A.z+s*(B.z-A.z)); };  // A+sAB
public pt S(pt P, float s, vec V) {return new pt(P.x + s*V.x, P.y + s*V.y, P.z + s*V.z); }            // P+sV
public vec S(vec U,float s,vec V) {return new vec(U.x+s*(V.x-U.x),U.y+s*(V.y-U.y),U.z+s*(V.z-U.z));};            // (1-s)U+sV

// ===== translate  
public pt S(pt P, vec V) {return new pt(P.x + V.x, P.y + V.y, P.z + V.z); }                          // P+V
public pt T(pt P, float s, vec V) {float n = n(V); if (n>0) return S(P,s/n,V);  else return P(P);}   // P+sV/||V|| move from P along direction of V by distance s
public pt T(pt P, float s, pt Q) {vec V = V(P,Q); return T(P,s,V) ; };                               // P+sPQ/||PQ|| move from P towards Q by distance s

// ===== rotate 
//pt R(pt Q, float a, pt P, vec N) {float dx=Q.x-P.x, dy=Q.y-P.y, c=cos(a), s=sin(a); return P(P.x+c*dx+s*dy, P.y-s*dx+c*dy); }; // Rotated Q by a around P
//pt R(pt Q, float a) {float dx=Q.x, dy=Q.y, c=cos(a), s=sin(a); return new pt(c*dx+s*dy, -s*dx+c*dy); };                 // Rotated Q by a around origin
//vec R(vec V, vec N) {return new vec(-V.y,V.x);};                                            // V turned right 90 degrees (around N)
//vec R(vec U, float a) {vec W = U.makeRotatedBy(a);  return W ; };                     // U rotated by a
//vec R(vec U, float s, vec V) {float a = angle(U,V); vec W = U.makeRotatedBy(s*a);     // interpolation (angle and length) between U and V
//    float u = n(U); float v=n(V); S((u+s*(v-u))/u,W); return W ; };
//float r(pt A, pt B, pt C) {return radius(A,B,C); };                                  // radius of circumcircle

// ===== render
public void showLine(pt P, pt Q) { line(Q.x,Q.y,Q.z,P.x,P.y,P.z); };  // draws edge (P,Q)
public void showLineFrom (pt P, vec V) {line(P.x,P.y,P.z,P.x+V.x,P.y+V.y,P.z+V.z); }; 
public void showLineFrom (pt P, vec V, float d) {line(P.x,P.y,P.z,P.x+d*V.x,P.y+d*V.y,P.z+d*V.z); }; 
public void v(pt P) {vertex(P.x,P.y,P.z);};                                                        // next vertex when drawing shapes between beginShape(); and endShape();

// ===== products
public float d(vec U, vec V) {return U.x*V.x+U.y*V.y+U.z*V.z; };                                          //U*V dot product
public float dot(vec U, vec V) {return U.x*V.x+U.y*V.y+U.z*V.z; };                                          //U*V dot product
public vec C(vec U, vec V) {return V( U.y*V.z-U.z*V.y, U.z*V.x-U.x*V.z, U.x*V.y-U.y*V.x); };              // UxV cross product
public vec cross(vec U, vec V) {return V( U.y*V.z-U.z*V.y, U.z*V.x-U.x*V.z, U.x*V.y-U.y*V.x); };              // UxV cross product
public float m(vec U, vec V, vec W) {return d(C(U,V),W); };                                         // (UxV)*W  mixed product, determinant
public float mixed(vec U, vec V, vec W) {return d(C(U,V),W); };                                         // (UxV)*W  mixed product, determinant

// ===== measures
public float d(pt P, pt Q) {return sqrt(sq(Q.x-P.x)+sq(Q.y-P.y)+sq(Q.z-P.z)); };                       // ||AB|| distance
public float n(vec V) {return sqrt(sq(V.x)+sq(V.y)+sq(V.z));};                                         // ||V||  norm
public float n2(vec V) {return sq(V.x)+sq(V.y)+sq(V.z);};                                              // V^V     norm squared
public boolean cw(vec U, vec V, vec W) {return m(U,V,W)>0; };                                           // (UxV)*W>0  U,V,W are clockwise
public float area(pt A, pt B, pt C) {return n(N(A,B,C))/2; };                                          // area of triangle 
public float volume(pt A, pt B, pt C, pt D) {return m(V(A,B),V(A,C),V(A,D))/6; };                      // volume of tet 
public boolean cw(pt A, pt B, pt C, pt D) {return volume(A,B,C,D)>0; };                                 // tet is oriented so that A sees B, C, D clockwise 
public vec B(vec U, vec V) {return U(C(C(U,V),U)); }                                                   // (UxV)xV unit normal to U in the plane UV
public boolean parallel (vec U, vec V) {return n(C(U,V))<n(U)*n(V)*0.00001f; }                          // true if U and V are almost parallel
public float a (vec U, vec V) {if (parallel(U,V)) { if (d(U,V)>0) return 0; else return PI;}; vec T=U(U); vec B=B(U,V); return atan2(d(B,V),d(T,V)); }; // angle(U,V) between 0 and PI

// ===== mouse
public pt Mouse() {return P(mouseX,mouseY,0);};                                          // current mouse location
public pt Pmouse() {return P(pmouseX,pmouseY,0);};
public vec MouseDrag() {return V(mouseX-pmouseX,mouseY-pmouseY,0);};                     // vector representing recent mouse displacement


/*
void show(pt P, vec V) {line(P.x,P.y,P.x+V.x,P.y+V.y); }                             // show line from P along V
void show(pt P, float s, vec V) {show(P,S(s,V));}                                    // show line from P along sV
void arrow(pt P, pt Q) {arrow(P,V(P,Q)); }                                           // draws arrow from P to Q
void arrow(pt P, float s, vec V) {arrow(P,S(s,V));}                                   // show arrow from P along sV
void arrow(pt P, vec V) {show(P,V);  float n=n(V); float s=max(min(0.2,20./n),6./n);  // show arrow from P along V
  pt Q=S(P,V); vec U = S(-s,V); vec W = R(S(.3,U)); beginShape(); v(S(S(Q,U),W)); v(Q); v(S(S(Q,U),-1,W)); endShape(CLOSE);}; 
boolean right(pt A, pt B, pt C) {return dot( A.makeVecTo(B).makeTurnedLeft() , B.makeVecTo(C) ) >0 ; };  // right turn (as seen on screen)
boolean isRightTurn(pt A, pt B, pt C) {return dot( R(V(A,B)),V(B,C)) > 0 ; };  // right turn (as seen on screen)
boolean isRightOf(pt A, pt Q, vec T) {return dot(R(T),V(Q,A)) > 0 ; };                   // A is on right of ray(Q,T) (as seen on screen)


float a(pt A, pt B, pt C) {return  a(V(B,A),V(B,C)); }                               // angle (A,B,C)
float area(pt A, pt B, pt C) {return 0.5*dot(V(A,C),R(V(A,B))); }                    // signed area of triangle
pt center (pt A, pt B, pt C) { vec AB = V(A,B); vec AC = R(V(A,C)); return S(A,1./2/dot(AB,AC),M(-n2(AC),R(AB),n2(AB),AC)); }; // circumcenter
*/

// ******************************************************************************************** POINTS 
class pt { float x,y,z; 
  pt (float px, float py, float pz) {x = px; y = py; z = pz;};
  public pt make() {return(new pt(x,y,z));};
  public void show(int r) { pushMatrix(); translate(x,y,z); sphere(r); popMatrix();}; 
  public void showLineTo (pt P) {line(x,y,z,P.x,P.y,P.z); }; 
  public void to (pt P) {line(x,y,z,P.x,P.y,P.z); }; 
  public void setToPoint(pt P) { x = P.x; y = P.y; z = P.z;}; 
  public void setTo(pt P) { x = P.x; y = P.y; z = P.z;}; 
  public void setTo(float px, float py, float pz) {x = px; y = py; z = pz;}; 
  public void setToMouse() { x = mouseX; y = mouseY; }; 
  public void write() {println("("+x+","+y+","+z+")");};
  public void addVec(vec V) {x += V.x; y += V.y; z += V.z;};
  public void addScaledVec(float s, vec V) {x += s*V.x; y += s*V.y; z += s*V.z;};
  public void moveTowards(float s, pt P) {x += s*(P.x-x); y += s*(P.y-y); z += s*(P.z-z);};
  public void subVec(vec V) {x -= V.x; y -= V.y; z -= V.z;};
  public void vert() {vertex(x,y,z);};
  public void vertext(float u, float v) {vertex(x,y,z,u,v);};
  public boolean isInWindow() {return(((x<0)||(x>width)||(y<0)||(y>height)));};
  public void label(String s, vec D) {text(s, x+D.x, y+D.y, z+D.z);  };
  public vec vecTo(pt P) {return(new vec(P.x-x,P.y-y,P.z-z)); };
  public float disTo(pt P) {return(sqrt( sq(P.x-x)+sq(P.y-y)+sq(P.z-z) )); };
  public vec vecToMid(pt P, pt Q) {return(new vec((P.x+Q.x)/2.0f-x,(P.y+Q.y)/2.0f-y,(P.z+Q.z)/2.0f-z )); };
  public vec vecToProp (pt B, pt D) {
      vec CB = this.vecTo(B); float LCB = CB.norm();
      vec CD = this.vecTo(D); float LCD = CD.norm();
      vec U = CB.make();
      vec V = CD.make(); V.sub(U); V.mul(LCB/(LCB+LCD));
      U.add(V);
      return(U);  
      };  
  public void addPt(pt P) {x+=P.x; y+=P.y; z+=P.z;};
  public void addPt(float s, pt P) {x+=s*P.x; y+=s*P.y; z+=s*P.z;};
  public void subPt(pt P) {x-=P.x; y-=P.y; z-=P.z; };
  public void mul(float f) {x*=f; y*=f; z*=f;};
  public void pers(float d) { y=d*y/(d+z); x=d*x/(d+z); z=d*z/(d+z); };
  public void inverserPers(float d) { y=d*y/(d-z); x=d*x/(d-z); z=d*z/(d-z); };
  public boolean coplanar (pt A, pt B, pt C) {return(abs(tetVol(this,A,B,C))<0.0001f);};
  public boolean cw (pt A, pt B, pt C) {return(tetVol(this,A,B,C)>0.0001f);};
  
  public void v() {vertex(x, y);}
  } ;
 
// ******************************************************************************************** VECTORS 
class vec { float x,y,z; 
  vec (float px, float py, float pz) {x = px; y = py; z = pz;};
  public void setTo (float px, float py, float pz) {x = px; y = py; z = pz;}; 
  public vec make() {return(new vec(x,y,z));};
  public void setToVec(vec V) { x = V.x; y = V.y; z = V.z;}; 
  public void setTo(vec V) { x = V.x; y = V.y; z = V.z;}; 
  public void show (pt P) {line(P.x,P.y, P.z,P.x+x,P.y+y,P.z+z); }; 
  public void add(vec V) {x += V.x; y += V.y; z += V.z;};
  public void addScaled(float m, vec V) {x += m*V.x; y += m*V.y; z += m*V.z;};
  public void sub(vec V) {x -= V.x; y -= V.y; z -= V.z;};
  public vec mul(float m) {x *= m; y *= m; z *= m; return this;};
  public void div(float m) {x /= m; y /= m; z /= m;};
  public void write() {println("("+x+","+y+","+z+")");};
  public float norm() {return(sqrt(sq(x)+sq(y)+sq(z)));}; 
  public void makeUnit() {float n=this.norm(); if (n>0.0001f) {this.div(n);};};
  public void back() {x= -x; y= -y; z= -z;};
  public boolean coplanar (vec V, vec W) {return(abs(m(this,V,W))<0.0001f);};
  public boolean cw (vec U, vec V, vec W) {return(m(this,V,W)>0.0001f);};
  } ;
  
  
// ******************************************************************************************** TRIANGLES  EDGES RAYS PLANES
public vec triNormalFromPts(pt A, pt B, pt C) {vec N = cross(A.vecTo(B),A.vecTo(C));  return(N); };
public boolean rayHitTri(pt E, pt M, pt A, pt B, pt C) { boolean s, sA, sB, sC; 
  s=(tetVolume(E,A,B,C)>0);  sA=(tetVolume(E,M,B,C)>0); sB=(tetVolume(E,A,M,C)>0);  sC=(tetVolume(E,A,B,M)>0); 
  return( (s==sA) && (s==sB) && (s==sC) );};
public float rayDistTriPlane(pt E, pt M, pt A, pt B, pt C) { 
   vec AE = A.vecTo(E); vec AC = A.vecTo(C); vec AB = A.vecTo(B); vec EM = E.vecTo(M); 
   float s = - mixed(AE,AC,AB) / mixed(EM,AC,AB);
   return(s); };
public pt triCenterFromPts(pt A, pt B, pt C) {return(new pt((A.x+B.x+C.x)/3 , (A.y+B.y+C.y)/3, (A.z+B.z+C.z)/3 )); };

// ******************************************************************************************** TETS 
public float tetVol (pt A, pt B, pt C, pt D) { return(dot(triNormalFromPts(A,B,C),A.vecTo(D))); };
public vec midVec(vec U, vec V) {return(new vec((U.x+V.x)/2,(U.y+V.y)/2,(U.z+V.z)/2)); };
public pt midPt(pt A, pt B) {return(new pt((A.x+B.x)/2 , (A.y+B.y)/2, (A.z+B.z)/2 )); };
public float tetVolume(pt E, pt A, pt B, pt C) {vec EA=E.vecTo(A); vec EB=E.vecTo(B); vec EC=E.vecTo(C); float v=mixed(EA,EB,EC); return(v/6); };

// ******************************************************************************************** RAYS 
   
//************************************************************************
//**** ANGLES
//************************************************************************
public float mPItoPIangle(float a) { if(a>PI) return(mPItoPIangle(a-2*PI)); if(a<-PI) return(mPItoPIangle(a+2*PI)); return(a);};
public float Oto2PIangle(float a) { if(a>TWO_PI) return(Oto2PIangle(a-2*PI)); if(a<0) return(Oto2PIangle(a+2*PI)); return(a);};
public float toDeg(float a) {return(a*180/PI);}
public float toRad(float a) {return(a*PI/180);}



public void scribe(String S) {fill(black); text(S,20,20); noFill();}
public void scribe(String S, int i) {fill(black); text(S,20,20+i*20); noFill();}
public void scribe(String S, int i, int j) {fill(black); text(S,width-10*j,20+i*20); noFill();}

public void keys() { 
  if (key==' ') { if (meshMode) showHelpText = true; showHelpText=!showHelpText;} 
  if (key=='?') printIt = !printIt;  // toggle debug mode
  //if  (47<int(key)) if (int(key)<56)  { int n=int(key)-48; mySelected(n);}    
  if(key=='a') spinAnimation = !spinAnimation;//animate=!animate;     
//  if(key=='c') myCopy();  
  if(key=='E') myDenoise();  
  if(key=='T') showEkey=!showEkey; 
//  if(key=='k') showKeys=!showKeys;  
//  if(key=='w') myTranslate();  // executed in my actions for faster response
//  if(key=='n') showMouseProjection=!showMouseProjection;
//  if(key=='p') myPaste();  
  if(key=='f') myRefine();  
  if(key=='A') mySample();  
//  if(key=='e') myRotate();  // executed in my actions for faster response
  if(key=='v') showVertices=!showVertices;  // toggle showing control vertices
  if(key=='<') { vc /= 2; if (vc < 3) vc = 3; for (int i = 0; i < kc; i++) CP[i].resample(vc); }
  if(key=='>') { vc *= 2; for (int i = 0; i < kc; i++) CP[i].resample(vc); }
  if(key==',') { sprayNum /= 2; if (sprayNum < 1) sprayNum = 1; }
  if(key=='.') { sprayNum *= 2; }
//  if(key=='z') myScale();  // executed in my actions for faster response
  if(key=='b') {loopToMesh(); bulge();}
  if(key=='h') mat = !mat;
  if(key=='H') matDisks = !matDisks;
  if(key=='S') M.laplace2D(1.0f/3.0f);
  if(key=='M') {meshMode = !meshMode; if (!meshMode && M.g().z < 0) M.c = O2D[M.c]; if (meshMode) showHelpText = false;}
  if (key=='I') {M.computeIsolation();}
  if (key=='D') {M.showDistance=!M.showDistance; if(M.showDistance) {M.computeDistance(maxr); println("showing distance");} else println("not showing distance");};
  if (key=='q') {C.setMark(); M.hitTriangle();/* C.F.setToPoint(mark); C.pullE(); C.pose(); */ M.writeCorner();}
  if (key=='[') {maxr--; if (maxr<1) maxr=1; M.computeDistance(maxr);};
  if (key==']') {maxr++; M.computeDistance(maxr);}
  if (key=='0') {maxr=0; M.computeDistance(maxr);}
  if (key=='P') {M.computePath(); M.showDistance=true; println("showing path"); println("not showing path"); };
  if (key=='N') {M.showNormals=!M.showNormals; if(M.showNormals) {M.normals(); println("showing normals");} else println("not showing normals"); }
  if (key=='n') M.c = M.n();
  if (key=='p') M.c = M.p();
  if (key=='o') M.c = M.o();
  if (key=='l') M.c = M.l();
  if (key=='r') M.c = M.r();
  if (key=='s') M.c = M.s();
  if (key=='m') mirror();
  if (key=='y') {coolSpray = !coolSpray; loopToMesh(); bulge();}
  if (key=='u') {matMin = true; matAverage = false; matMax = false; loopToMesh(); bulge();}
  if (key=='j') {matMin = false; matAverage = true; matMax = false; loopToMesh(); bulge();}
  if (key=='i') {matMin = false; matAverage = false; matMax = true; loopToMesh(); bulge();}

  if (key=='L') {myLoad(); mySelected(0);}
//  if (key=='R') myReset();
  if (key=='W') mySave(); 
  if (key=='X') picture(); 
  };     

public void updateView() {
  //if (keyCode==SHIFT) {C.Pan(); C.pullE(); };
  //if (keyCode==CONTROL) {C.turn(); C.pullE(); };  
  if (key=='z') {C.pose(); C.zoom(); C.pullE(); };
  // if (key=='1') {C.pose(); C.fly(1.0); C.pullE(); };  
  // if (key=='2') {C.pose(); C.Pan(); C.pullE(); };
  // if (key=='3') {C.pose(); C.fly(-1.0); C.pullE();  };
  // if (key=='v') {C.pose(); C.Turn(); C.pullE(); };
  // if (key=='5') {C.pan(); C.pullE(); }; 
  // if (key=='w') {M.moveROI();}; 
  // if (key=='m') {M.move();}; 
  }

public void showHelp() {
    fill(dblue); pushMatrix(); translate(20,20);
     text("Polyloop and Mesh Manipulation by Michael Cook, Derek Tatum, and Patrick Jahn",0,0); translate(0,20);               // **P04
     text("  ",0,0); translate(0,20);
     text("First click in the window to activate it ",0,0); translate(0,20);
     text("Press SPACE to show/hide this help text",0,0); translate(0,20);
     text("  ",0,0); translate(0,20);
     text("While in Polyloop View",0,0); translate(0,20);
     text("  ",0,0); translate(0,20);
     text("Hold and drag to:",0,0); translate(0,20);
     text(" 'w':translate, 'z':scale, 'e':rotate, 'f':refine, 'A':resample, 'E':denoise.",0,0); translate(0,20);
     text("  ",0,0); translate(0,20);
     text("You can also use '<' and '>' to half or double the number of control vertices",0,0); translate(0,20);
     text("Or ',' and '.' to half/double the number of spray points. Use 'y' to toggle the spray mode",0,0); translate(0,20);
     text("  ",0,0); translate(0,20);
     text("Use 'S' to Laplace smooth and 'b' to perform the bulge. Then press 'M' to convert to Mesh View.",0,0); translate(0,20);
     text("Use 'u', 'j', and 'i' to use the min, average, or max (respectively) for bulge radius",0,0); translate(0,20);
     text("  ",0,0); translate(0,20);
     text("While in Mesh View",0,0); translate(0,20);
     text("",0,0); translate(0,20);
     text("Press 'm' to mirror the mesh, and 'N' to display the triangle and vertex normals.",0,0); translate(0,20);
     text("  ",0,0); translate(0,20);
     text("Press 'D' to shift to Distance Mode, then 'I' to turn on Isolation Measure. Use '[' and ']'",0,0); translate(0,20);
     text("to increment how many triangle units to travel. Hover and hit 'q' to pick two triangles",0,0); translate(0,20);
     text("and then 'P' to color in the shortest geodesic distance between the two triangles.",0,0); translate(0,20); 
     text("  ",0,0); translate(0,20);
     text("Use 'n','p','o','s','l','r' to perform those corner operations in Mesh or Polyloop View.",0,0); translate(0,20);
     text("  ",0,0); translate(0,20);
     text("Press 'a' to animate your mesh rotating around its y axis!",0,0); translate(0,20);
     popMatrix(); noFill();
   }
     
// CORNER TABLE FOR TRIANGLE MESHES by Jarek Rosignac
// Last edited Feb 17, 2008

Mesh M = new Mesh();     // creates a default triangle meshvoid computeValenceAndResetNormals() {      // caches valence of each vertex
 
//========================== class MESH ===============================
class Mesh {

public void importPolyloop(Polyloop P){
this.init(); //zeros out the mesh
for(int i=0;i<P.vn;i++){G[nv++]= new pt(P.P[i].x , P.P[i].y , 0);}
}
  
//  ==================================== INIT, CREATE, COPY ====================================
 Mesh() {declare();}
 int maxnv = 30000;                         //  max number of vertices
 int maxnt = maxnv*2;                       // max number of triangles
 public void declare() {c=0; sc=0; prevc=0;
   for (int i=0; i<maxnv; i++) {G[i]=new pt(0,0,0); Nv[i]=new vec(0,0,0);};   // init vertices and normals
   for (int i=0; i<maxnt; i++) {Nt[i]=new vec(0,0,0); visible[i]=true;} ;}       // init triangle normals and skeleton lab els
 public void init() {c=0; prevc=0; sc=0; nv=0; nt=0; nc=0;  for (int i=0; i<maxnt; i++) visible[i]=true;}
 public void makeGrid (int w) { // make a 2D grid of vertices
  for (int i=0; i<w; i++) {for (int j=0; j<w; j++) { G[w*i+j].setTo(height*.8f*j/(w-1)+height/10,height*.8f*i/(w-1)+height/10,0);}}    
  for (int i=0; i<w-1; i++) {for (int j=0; j<w-1; j++) {                  // define the triangles for the grid
    V[(i*(w-1)+j)*6]=i*w+j;       V[(i*(w-1)+j)*6+2]=(i+1)*w+j;       V[(i*(w-1)+j)*6+1]=(i+1)*w+j+1;
    V[(i*(w-1)+j)*6+3]=i*w+j;     V[(i*(w-1)+j)*6+5]=(i+1)*w+j+1;     V[(i*(w-1)+j)*6+4]=i*w+j+1;}; };
  nv = w*w;
  nt = 2*(w-1)*(w-1); 
  nc=3*nt;  }
 public void update() {computeO(); normals(); }
  // ============================================= CORNER OPERATORS =======================================
 int nc = 0;                                // current number of corners (3 per triangle)
 int c = 0;                                 // current corner shown in image and manipulated with keys: n, p, o, l, r
 int sc=0;                                  // saved value of c
 int[] V = new int [3*maxnt];               // V table (triangle/vertex indices)
 int[] O = new int [3*maxnt];               // O table (opposite corner indices)
 int[] Tc = new int[3*maxnt];               // corner type

// operations on a corner
public int t (int c) {return PApplet.parseInt(c/3);};          // triangle of corner    
public int n (int c) {return 3*t(c)+(c+1)%3;};   // next corner in the same t(c)    
public int p (int c) {return n(n(c));};  // previous corner in the same t(c)  
public int v (int c) {return V[c] ;};   // id of the vertex of c             
public pt g (int c) {return G[v(c)];};  // shortcut to get the point of the vertex v(c) of corner c
public boolean b (int c) {return O[c]==-1;};       // if faces a border (has no opposite)
public int o (int c) {if (b(c)) return c; else return O[c];}; // opposite (or self if it has no opposite)
public int l (int c) {return o(n(c));}; // left neighbor (or next if n(c) has no opposite)                      
public int r (int c) {return o(p(c));}; // right neighbor (or previous if p(c) has no opposite)                    
public int s (int c) {return n(l(c));}; // swings around v(c) or around a border loop

// operations on the selected corner c
public int t() {return t(c);}
public int n() {return n(c);}
public int p() {return p(c);}
 public int v() {return v(c);}
public int o() {return o(c);}
public boolean b() {return b(c);}             // border: returns true if corner has no opposite
public int l() {return l(c);}
public int r() {return r(c);}
public int s() {return s(c);}
public pt g() {return g(c);}            // shortcut to get the point of the vertex v(c) of corner c

public vec Nv (int c) {return(Nv[V[c]]);}; public vec Nv() {return Nv(c);}            // shortcut to get the normal of v(c) 
public vec Nt (int c) {return(Nt[t(c)]);}; public vec Nt() {return Nt(c);}            // shortcut to get the normal of t(c) 
public int w (int c) {return(W[c]);};               // temporary indices to mid-edge vertices associated with corners during subdivision
public boolean vis(int c) {return visible[t(c)]; };   // true if tiangle of c is visible
  
public void previous() {c=p(c);};
public void next() {c=n(c); println("...... next");};
public void back() {if(!b(c)) {c=o(c);};};
public void left() {next(); back();};
public void right() {previous(); back();};
public void swing() {left(); next(); };

public void writeCorner (int c) {println("c="+c+", n="+n(c)+", p="+p(c)+", o="+o(c)+", v="+v(c)+", t="+t(c)+", EB symbol="+triangleSymbol[t(c)]+"."+", nt="+nt+", nv="+nv ); }; 
public void writeCorner () {writeCorner (c);}
public void writeCorners () {for (int c=0; c<nc; c++) {println("T["+c+"]="+t(c)+", visible="+visible[t(c)]+", v="+v(c)+",  o="+o(c));};}

public pt cg(int c) {pt cPt = midPt(g(c),midPt(g(c),triCenter(t(c))));  return(cPt); };   // computes point at corner
public pt corner(int c) {return midPt(g(c),triCenter(t(c)));   };   // returns corner point
public void showCorner(int c, int r) {pt cPt = midPt(g(c),midPt(g(c),corner(c)));  cPt.show(r); };   // renders corner c as small ball
public void showCornerRotate(int c, int r) {
  pt cPt = midPt(g(c),midPt(g(c),corner(c))); //the midPt method takes in two pt for parameters
  cPt.x = cPt.x - (leftmostVertValue + distanceFromVertVals/2); //move to the left
  cPt.show(r);
  cPt.x = cPt.x + (leftmostVertValue + distanceFromVertVals/2);  //move back to the right
};
// ============================================= O TABLE CONSTRUCTION =========================================
public void computeOnaive() {                         // sets the O table from the V table, assumes consistent orientation of triangles
  for (int i=0; i<3*nt; i++) {O[i]=-1;};  // init O table to -1: has no opposite (i.e. is a border corner)
  for (int i=0; i<nc; i++) {  for (int j=i+1; j<nc; j++) {       // for each corner i, for each other corner j
      if( (v(n(i))==v(p(j))) && (v(p(i))==v(n(j))) ) {O[i]=j; O[j]=i;};};};}// make i and j opposite if they match         

public void computeO() { 
  int val[] = new int [nv]; for (int v=0; v<nv; v++) val[v]=0;  for (int c=0; c<nc; c++) val[v(c)]++;   //  valences
  int fic[] = new int [nv]; int rfic=0; for (int v=0; v<nv; v++) {fic[v]=rfic; rfic+=val[v];};  // head of list of incident corners
  for (int v=0; v<nv; v++) val[v]=0;   // valences wil be reused to track how many incident corners were encountered for each vertex
  int [] C = new int [nc]; for (int c=0; c<nc; c++) C[fic[v(c)]+val[v(c)]++]=c;  // vor each vertex: the list of val[v] incident corners starts at C[fic[v]]
  for (int c=0; c<nc; c++) O[c]=-1;    // init O table to -1 meaning that a corner has no opposite (i.e. faces a border)
  for (int v=0; v<nv; v++)             // for each vertex...
     for (int a=fic[v]; a<fic[v]+val[v]-1; a++) for (int b=a+1; b<fic[v]+val[v]; b++)  { // for each pair (C[a],C[b[]) of its incident corners
        if (v(n(C[a]))==v(p(C[b]))) {O[p(C[a])]=n(C[b]); O[n(C[b])]=p(C[a]); }; // if C[a] follows C[b] around v, then p(C[a]) and n(C[b]) are opposite
        if (v(n(C[b]))==v(p(C[a]))) {O[p(C[b])]=n(C[a]); O[n(C[a])]=p(C[b]); };        };                }
    
// ============================================= DISPLAY =======================================
pt Cbox = new pt(width/2,height/2,0);                   // mini-max box center
float Rbox=1000;                                        // Radius of enclosing ball
boolean showLabels=false; 
public void computeBox() {
  pt Lbox =  G[0].make();  pt Hbox =  G[0].make();
  for (int i=1; i<nv; i++) { 
    Lbox.x=min(Lbox.x,G[i].x); Lbox.y=min(Lbox.y,G[i].y); Lbox.z=min(Lbox.z,G[i].z);
    Hbox.x=max(Hbox.x,G[i].x); Hbox.y=max(Hbox.y,G[i].y); Hbox.z=max(Hbox.z,G[i].z); 
    };
  Cbox.setToPoint(midPt(Lbox,Hbox));  Rbox=Cbox.disTo(Hbox);
  };
public void show() {
  int col=60;
  noSmooth(); noStroke();
  if (spinAnimation) rotateHelper();
  
  if(showDistance) showDistance(); else if(showEB) showEB();  //else if(showTriangles){
    //if(spinAnimation)M.showTrianglesRotate();  
    else showTriangles();
  //}  
  if (showEdges) {stroke(dblue); for(int i=0; i<nc; i++) if(visible[t(i)]) drawEdge(i); };  
  if (showSelectedTriangle) {noStroke(); fill(green); shade(t(c)); noFill(); }; 
  stroke(red); showBorder();
  if (showVertices) {noStroke(); noSmooth();fill(white); for (int v=0; v<nv; v++)  G[v].show(r); noFill();};
  if (showNormals) {stroke(blue); showTriNormals(); stroke(magenta); showVertexNormals(); };                // show triangle normals
  if (showLabels) { fill(black); 
      for (int i=0; i<nv; i++) {G[i].label("v"+str(i),labelD); }; 
      for (int i=0; i<nc; i++) {corner(i).label("c"+str(i),labelD); }; 
      for (int i=0; i<nt; i++) {triCenter(i).label("t"+str(i),labelD); }; noFill();};
  noStroke();
  fill(dred);
  //if(spinAnimation)showCornerRotate(prevc,r);
  /*else*/ showCorner(prevc,r);
  fill(dgreen); mark.show(PApplet.parseInt(1.5f*r));
  fill(dblue);
  //if(spinAnimation)showCornerRotate(c,int(2*r));
  /*else*/ showCorner(c,PApplet.parseInt(2*r));
  
  if (spinAnimation) endRotateHelper();
}
//  ==========================================================  EDGES ===========================================
boolean showEdges=false;
public void findShortestEdge() {c=cornerOfShortestEdge();  } 
public int cornerOfShortestEdge() {  // assumes manifold
  float md=d(g(p(0)),g(n(0))); int ma=0;
  for (int a=1; a<nc; a++) if (vis(a)&&(d(g(p(a)),g(n(a)))<md)) {ma=a; md=d(g(p(a)),g(n(a)));}; 
  return ma;
  } 
public void drawEdge(int c) {showLine(g(p(c)),g(n(c))); };  // draws edge of t(c) opposite to corner c
public void showBorder() {for (int i=0; i<nc; i++) {if (visible[t(i)]&&b(i)) {drawEdge(i);}; }; };         // draws all border edges

//  ==========================================================  TRIANGLES ===========================================
 boolean showTriangles=true;
 boolean showSelectedTriangle=false;
 int nt = 0;                   // current number of triangles
 public void addTriangle(int i, int j, int k) {V[nc++]=i; V[nc++]=j; V[nc++]=k; visible[nt++]=true;}
 boolean[] visible = new boolean[maxnt];    // set if triangle visible
 int[] Mt = new int[maxnt];                 // triangle markers for distance and other things   
 boolean [] VisitedT = new boolean [maxnt];  // triangle visited
 public pt triCenter(int i) {return(triCenterFromPts( G[V[3*i]], G[V[3*i+1]], G[V[3*i+2]] )); };  public pt triCenter() {return triCenter(t());}  // computes center of triangle t(i) 
 public void writeTri (int i) {println("T"+i+": V = ("+V[3*i]+":"+v(o(3*i))+","+V[3*i+1]+":"+v(o(3*i+1))+","+V[3*i+2]+":"+v(o(3*i+2))+")"); };
 public void hitTriangle() {
  prevc=c;       // save c for geodesic and other applications
  float smallestDepth=10000000;
  boolean hit=false;
  for (int t=0; t<nt; t++) {
    if (rayHitTri(eye,mark,g(3*t),g(3*t+1),g(3*t+2))) {hit=true;
      float depth = rayDistTriPlane(eye,mark,g(3*t),g(3*t+1),g(3*t+2));
      if ((depth>0)&&(depth<smallestDepth)) {smallestDepth=depth;  c=3*t;};
      }; 
    };
  if (hit) {        // sets c to be the closest corner in t(c) to the picked point
    pt X = eye.make(); X.addScaledVec(smallestDepth,eye.vecTo(mark));
    mark.setToPoint(X);
    float distance=X.disTo(g(c));
    int b=c;
    if (X.disTo(g(n(c)))<distance) {b=n(c); distance=X.disTo(g(b)); };
    if (X.disTo(g(p(c)))<distance) {b=p(c);};
    c=b;
    println("c="+c+", pc="+prevc+", t(pc)="+t(prevc));
    };
  }
 public void shade(int t) {if(visible[t]) { beginShape(TRIANGLES); g(3*t).vert(); g(3*t+1).vert(); g(3*t+2).vert();  endShape(); };}; // shade tris
 public void showTriangles() {fill(cyan); for(int t=0; t<nt; t++)  shade(t); noFill();}; 
 
 public void showTrianglesRotate() {
   /*spinAnimCounter++;
   fill(cyan);
   println(G[0].x);
   for(int i=0;i<nv;i++){
     if(i==0){leftmostVertValue=G[i].x;rightmostVertValue=G[i].x;}
     else if(G[i].x<leftmostVertValue){leftmostVertValue=G[i].x;}
     else if(G[i].x>rightmostVertValue){rightmostVertValue=G[i].x;}
   }
   distanceFromVertVals = rightmostVertValue - leftmostVertValue;
   for(int i=0;i<nv;i++){G[i].x=G[i].x-(leftmostVertValue + distanceFromVertVals/2);} //move left
   translate(width/2+40,0,0); //added the + 40
   rotateY(spinAnimCounter*TWO_PI/100);
   for(int t=0; t<nt; t++){shade(t);}
   noFill();
   for(int i=0;i<nv;i++){G[i].x=G[i].x+(leftmostVertValue + distanceFromVertVals/2);}   //move back to right   */
 };
 
 public void rotateHelper() {
   spinAnimCounter++;
   for(int i=0;i<nv;i++){
     if(i==0){leftmostVertValue=G[i].x;rightmostVertValue=G[i].x;}
     else if(G[i].x<leftmostVertValue){leftmostVertValue=G[i].x;}
     else if(G[i].x>rightmostVertValue){rightmostVertValue=G[i].x;}
   }
   distanceFromVertVals = rightmostVertValue - leftmostVertValue;
   for(int i=0;i<nv;i++){G[i].x=G[i].x-(leftmostVertValue + distanceFromVertVals/2);} //move left
   mark.x -= leftmostVertValue + distanceFromVertVals/2;
   translate(leftmostVertValue + distanceFromVertVals/2, 0, 0); // move to center
   rotateY(spinAnimCounter*TWO_PI/100);
 }
 
 public void endRotateHelper() {
   for(int i=0;i<nv;i++){G[i].x=G[i].x+(leftmostVertValue + distanceFromVertVals/2);}   //move back to right
   mark.x += leftmostVertValue + distanceFromVertVals/2;
 }
//  ==========================================================  VERTICES ===========================================
 boolean showVertices=false;
 int nv = 0;                              // current  number of vertices
 pt[] G = new pt [maxnv];                   // geometry table (vertices)
 int[] Mv = new int[maxnv];                  // vertex markers
 int [] Valence = new int [maxnv];          // vertex valence (count of incident triangles)
 boolean [] Border = new boolean [maxnv];   // vertex is border
 boolean [] VisitedV = new boolean [maxnv];  // vertex visited
 int r=5;                                // radius of spheres for displaying vertices
public int addVertex(pt P) { G[nv].setTo(P); nv++; return nv-1;};
public int addVertex(float x, float y, float z) { G[nv].x=x; G[nv].y=y; G[nv].z=z; nv++; return nv-1;};
public void move(int c) {g(c).addScaledVec(pmouseY-mouseY,Nv(c));}
public void move(int c, float d) {g(c).addScaledVec(d,Nv(c));}
public void move() {move(c); normals();}
public void moveROI() {
     pt Q = new pt(0,0,0);
     for (int i=0; i<nv; i++) Mv[i]=0;  // resets the valences to 0
     computeDistance(5);
     for (int i=0; i<nv; i++) VisitedV[i]=false;  // resets the valences to 0
     computeTriNormals(); computeVertexNormals();
     for (int i=0; i<nc; i++) if(!VisitedV[v(i)]&&(Mv[v(i)]!=0)) move(i,1.f*(pmouseY-mouseY+mouseX-pmouseX)*(rings-Mv[v(i)])/rings/10);  // moves ROI
     computeDistance(7);
     Q.setTo(g());
     smoothROI();
     g().setTo(Q);
     }
     
//  ==========================================================  NORMALS ===========================================
boolean showNormals=false;
vec[] Nv = new vec [maxnv];                 // vertex normals or laplace vectors
vec[] Nt = new vec [maxnt];                // triangles normals
public void normals() {computeValenceAndResetNormals(); computeTriNormals(); computeVertexNormals(); }
public void computeValenceAndResetNormals() {      // caches valence of each vertex
  for (int i=0; i<nv; i++) {Nv[i].setTo(0,0,0); Valence[i]=0;};  // resets the valences to 0
  for (int i=0; i<nc; i++) {Valence[v(i)]++; };
  }
public vec triNormal(int t) { return C(V(g(3*t),g(3*t+1)),V(g(3*t),g(3*t+2))); };  
public vec triNormal() {return triNormal(t());} // computes triangle t(i) normal * area / 2
public void computeTriNormals() {for (int i=0; i<nt; i++) {Nt[i].setToVec(triNormal(i)); }; };             // caches normals of all tirangles
public void computeVertexNormals() {  // computes the vertex normals as sums of the normal vectors of incident tirangles scaled by area/2
  for (int i=0; i<nv; i++) {Nv[i].setTo(0,0,0);};  // resets the valences to 0
  for (int i=0; i<nc; i++) {Nv[v(i)].add(Nt[t(i)]);};
  for (int i=0; i<nv; i++) {Nv[i].makeUnit();};            };
public void showCornerNormal(int c) {S(20*r,Nt[t(c)]).show(M(g(c),g(c),triCenter(t(c))));};   // renders corner normal
public void showVertexNormals() {for (int i=0; i<nv; i++) S(10*r,Nv[i]).show(G[i]);  };
public void showTriNormals() {for (int i=0; i<nt; i++) S(10*r,U(Nt[i])).show(triCenter(i));  };

// ============================================================= SMOOTHING ============================================================
public void computeLaplaceVectors() {  // computes the vertex normals as sums of the normal vectors of incident tirangles scaled by area/2
  computeValenceAndResetNormals();
  for (int i=0; i<3*nt; i++) {Nv[v(p(i))].add(g(p(i)).vecTo(g(n(i))));};
  for (int i=0; i<nv; i++) {Nv[i].div(Valence[i]);};                         };
public void tuck(float s) {for (int i=0; i<nv; i++) {G[i].addScaledVec(s,Nv[i]);}; };  // displaces each vertex by a fraction s of its normal
public void smoothen() {normals(); computeLaplaceVectors(); tuck(0.6f); computeLaplaceVectors(); tuck(-0.6f);};
public void tuckROI(float s) {for (int i=0; i<nv; i++) if (Mv[i]!=0) G[i].addScaledVec(s,Nv[i]); };  // displaces each vertex by a fraction s of its normal
public void smoothROI() {computeLaplaceVectors(); tuckROI(0.5f); computeLaplaceVectors(); tuckROI(-0.5f);};
// ============================================================= SUBDIVISION ============================================================
int[] W = new int [3*maxnt];               // mid-edge vertex indices for subdivision (associated with corner opposite to edge)
public void splitEdges() {            // creates a new vertex for each edge and stores its ID in the W of the corner (and of its opposite if any)
  for (int i=0; i<3*nt; i++) {  // for each corner i
    if(b(i)) {G[nv]=midPt(g(n(i)),g(p(i))); W[i]=nv++;}
    else {if(i<o(i)) {G[nv]=midPt(g(n(i)),g(p(i))); W[o(i)]=nv; W[i]=nv++; }; }; }; } // if this corner is the first to see the edge
  
public void bulge() {              // tweaks the new mid-edge vertices according to the Butterfly mask
  for (int i=0; i<3*nt; i++) {
    if((!b(i))&&(i<o(i))) {    // no tweak for mid-vertices of border edges
     if (!b(p(i))&&!b(n(i))&&!b(p(o(i)))&&!b(n(o(i))))
      {G[W[i]].addScaledVec(0.25f,midPt(midPt(g(l(i)),g(r(i))),midPt(g(l(o(i))),g(r(o(i))))).vecTo(midPt(g(i),g(o(i))))); }; }; }; };
  
public void splitTriangles() {    // splits each tirangle into 4
  for (int i=0; i<3*nt; i=i+3) {
    V[3*nt+i]=v(i); V[n(3*nt+i)]=w(p(i)); V[p(3*nt+i)]=w(n(i));
    V[6*nt+i]=v(n(i)); V[n(6*nt+i)]=w(i); V[p(6*nt+i)]=w(p(i));
    V[9*nt+i]=v(p(i)); V[n(9*nt+i)]=w(n(i)); V[p(9*nt+i)]=w(i);
    V[i]=w(i); V[n(i)]=w(n(i)); V[p(i)]=w(p(i));
    };
  nt=4*nt; nc=3*nt;  };
  
public void refine() {update(); splitEdges(); bulge(); splitTriangles(); update();}
  
//  ========================================================== FILL HOLES ===========================================
public void fanHoles() {for (int cc=0; cc<nc; cc++) if (visible[t(cc)]&&b(cc)) fanThisHole(cc); normals();  }
public void fanThisHole() {fanThisHole(c);}
public void fanThisHole(int cc) {   // fill shole with triangle fan (around average of parallelogram predictors). Must then call computeO to restore O table
 if(!b(cc)) return ; // stop if cc is not facing a border
 G[nv].setTo(0,0,0);   // tip vertex of fan
 int o=0;              // tip corner of new fan triangle
 int n=0;              // triangle count in fan
 int a=n(cc);          // corner running along the border
 while (n(a)!=cc) {    // walk around the border loop 
   if(b(p(a))) {       // when a is at the left-end of a border edge
      G[nv].addPt( M(M(g(a),g(n(a))),S(g(a),V(g(p(a)),g(n(a))))) ); // add parallelogram prediction and mid-edge point
      o=3*nt; V[o]=nv; V[n(o)]=v(n(a)); V[p(o)]=v(a); visible[nt]=true; nt++; // add triangle to V table, make it visible
      O[o]=p(a); O[p(a)]=o;        // link opposites for tip corner
      O[n(o)]=-1; O[p(o)]=-1;
      n++;}; // increase triangle-count in fan
    a=s(a);} // next corner along border
 G[nv].mul(1.f/n); // divide fan tip to make it the average of all predictions
 a=o(cc);       // reset a to walk around the fan again and set up O
 int l=n(a);   // keep track of previous
 int i=0; 
 while(i<n) {a=s(a); if(v(a)==nv) { i++; O[p(a)]=l; O[l]=p(a); l=n(a);}; };  // set O around the fan
 nv++;  nc=3*nt;  // update vertex count and corner count
 };

// =========================================== GEODESIC MEASURES, DISTANCES =============================
 boolean  showPath=false, showDistance=false;  
 boolean[] P = new boolean [3*maxnt];       // marker of corners in a path to parent triangle
 int[] Distance = new int[maxnt];           // triangle markers for distance fields 
 int[] SMt = new int[maxnt];                // sum of triangle markers for isolation
 int prevc = 0;                             // previously selected corner
 int rings=2;                           // number of rings for colorcoding

public void computeDistance(int maxr) {
  int tc=0;
  int r=1;
  for(int i=0; i<nt; i++) {Mt[i]=0;};  Mt[t(c)]=1; tc++;
  for(int i=0; i<nv; i++) {Mv[i]=0;};
  while ((tc<nt)&&(r<=maxr)) {
      for(int i=0; i<nc; i++) {if ((Mv[v(i)]==0)&&(Mt[t(i)]==r)) {Mv[v(i)]=r;};};
     for(int i=0; i<nc; i++) {if ((Mt[t(i)]==0)&&(Mv[v(i)]==r)) {Mt[t(i)]=r+1; tc++;};};
     r++;
     };
  rings=r;
  }
  
public void computeIsolation() {
  println("Starting isolation computation for "+nt+" triangles");
  for(int i=0; i<nt; i++) {SMt[i]=0;}; 
  for(c=0; c<nc; c+=3) {println("  triangle "+t(c)+"/"+nt); computeDistance(1000); for(int j=0; j<nt; j++) {SMt[j]+=Mt[j];}; };
  int L=SMt[0], H=SMt[0];  for(int i=0; i<nt; i++) { H=max(H,SMt[i]); L=min(L,SMt[i]);}; if (H==L) {H++;};
  c=0; for(int i=0; i<nt; i++) {Mt[i]=(SMt[i]-L)*255/(H-L); if (Mt[i] == 0) Mt[i] = 1;/* used to make everyone colored*/ if(Mt[i]>Mt[t(c)]) {c=3*i;};}; rings=255;
  for(int i=0; i<nv; i++) {Mv[i]=0;};  for(int i=0; i<nc; i++) {Mv[v(i)]=max(Mv[v(i)],Mt[t(i)]);};
  println("finished isolation");
  }
  
public void computePath() {                 // graph based shortest path between t(c0 and t(prevc), prevc is the previously picekd corner
  for(int i=0; i<nt; i++) {Mt[i]=0;}; Mt[t(prevc)]=1; // Mt[0]=1;
  for(int i=0; i<nc; i++) {P[i]=false;};
  int r=1;
  boolean searching=true;
  while (searching) {
     for(int i=0; i<nc; i++) {
       if (searching&&(Mt[t(i)]==0)&&(o(i)!=-1)) {
         if(Mt[t(o(i))]==r) {
           Mt[t(i)]=r+1; 
           P[i]=true; 
           if(t(i)==t(c)){searching=false;};
           };
         };
       };
     r++;
     };
  for(int i=0; i<nt; i++) {Mt[i]=0;};  // graph distance between triangle and t(c)
  rings=1;      // track ring number
  int b=c;
  int k=0;
   while (t(b)!=t(prevc)) {rings++;  
   if (P[b]) {b=o(b); print(".o");} else {if (P[p(b)]) {b=r(b);print(".r");} else {b=l(b);print(".l");};}; Mt[t(b)]=rings; };
  }
 public void  showDistance() { for(int t=0; t<nt; t++) {if(Mt[t]==0) fill(cyan); else fill(ramp(Mt[t],rings)); shade(t);}; } 

//  ==========================================================  DELETE ===========================================
public void hideROI() { for(int i=0; i<nt; i++) if(Mt[i]>0) visible[i]=false; }

//  ==========================================================  GARBAGE COLLECTION ===========================================
public void clean() {excludeInvisibleTriangles();  compactVO(); compactV(); M.normals();}  // removes deleted triangles and unused vertices
public void excludeInvisibleTriangles () {for (int b=0; b<nc; b++) {if (!visible[t(o(b))]) {O[b]=-1;};};}
public void compactVO() {  
  int[] U = new int [nc];
  int lc=-1; for (int c=0; c<nc; c++) {if (visible[t(c)]) {U[c]=++lc; }; };
  for (int c=0; c<nc; c++) {if (!b(c)) {O[c]=U[o(c)];} else {O[c]=-1;}; };
  int lt=0;
  for (int t=0; t<nt; t++) {
    if (visible[t]) {
      V[3*lt]=V[3*t]; V[3*lt+1]=V[3*t+1]; V[3*lt+2]=V[3*t+2]; 
      O[3*lt]=O[3*t]; O[3*lt+1]=O[3*t+1]; O[3*lt+2]=O[3*t+2]; 
      visible[lt]=true; 
      lt++;
      };
    };
  nt=lt; nc=3*nt;    
  println("      ...  NOW: nv="+nv +", nt="+nt +", nc="+nc );
  }

public void compactV() {  
  println("COMPACT VERTICES: nv="+nv +", nt="+nt +", nc="+nc );
  int[] U = new int [nv];
  boolean[] deleted = new boolean [nv];
  for (int v=0; v<nv; v++) {deleted[v]=true;};
  for (int c=0; c<nc; c++) {deleted[v(c)]=false;};
  int lv=-1; for (int v=0; v<nv; v++) {if (!deleted[v]) {U[v]=++lv; }; };
  for (int c=0; c<nc; c++) {V[c]=U[v(c)]; };
  lv=0;
  for (int v=0; v<nv; v++) {
    if (!deleted[v]) {G[lv].setToPoint(G[v]);  deleted[lv]=false; 
      lv++;
      };
    };
 nv=lv;
 println("      ...  NOW: nv="+nv +", nt="+nt +", nc="+nc );
  }

// ============================================================= ARCHIVAL ============================================================
boolean flipOrientation=false;            // if set, save will flip all triangles

/*void saveMesh() {
  String [] inppts = new String [nv+1+nt+1];
  int s=0;
  inppts[s++]=str(nv);
  for (int i=0; i<nv; i++) {inppts[s++]=str(G[i].x)+","+str(G[i].y)+","+str(G[i].z);};
  inppts[s++]=str(nt);
  if (flipOrientation) {for (int i=0; i<nt; i++) {inppts[s++]=str(V[3*i])+","+str(V[3*i+2])+","+str(V[3*i+1]);};}
    else {for (int i=0; i<nt; i++) {inppts[s++]=str(V[3*i])+","+str(V[3*i+1])+","+str(V[3*i+2]);};};
  saveStrings("mesh.vts",inppts);  println("saved on file");
  };

void loadMesh() {
  println("loading fn["+fni+"]: "+fn[fni]); 
  String [] ss = loadStrings(fn[fni]);
  String subpts;
  int s=0;   int comma1, comma2;   float x, y, z;   int a, b, c;
  nv = int(ss[s++]);
    print("nv="+nv);
    for(int k=0; k<nv; k++) {int i=k+s; 
      comma1=ss[i].indexOf(',');   
      x=float(ss[i].substring(0, comma1));
      String rest = ss[i].substring(comma1+1, ss[i].length());
      comma2=rest.indexOf(',');    y=float(rest.substring(0, comma2)); z=float(rest.substring(comma2+1, rest.length()));
      G[k].setTo(x,y,z);
    };
  s=nv+1;
  nt = int(ss[s]); nc=3*nt;
  println(", nt="+nt);
  s++;
  for(int k=0; k<nt; k++) {int i=k+s;
      comma1=ss[i].indexOf(',');   a=int(ss[i].substring(0, comma1));  
      String rest = ss[i].substring(comma1+1, ss[i].length()); comma2=rest.indexOf(',');  
      b=int(rest.substring(0, comma2)); c=int(rest.substring(comma2+1, rest.length()));
      V[3*k]=a;  V[3*k+1]=b;  V[3*k+2]=c;
    }
  };*/

//  ==========================================================  FLIP ===========================================
public void flipWhenLonger() {for (int c=0; c<nc; c++) if (d(g(n(c)),g(p(c)))>d(g(c),g(o(c)))) flip(c); } 
public void flip() {flip(c);}
public void flip(int c) {      // flip edge opposite to corner c, FIX border cases
  if (b(c)) return;
    V[n(o(c))]=v(c); V[n(c)]=v(o(c));
    int co=o(c); O[co]=r(c); if(!b(p(c))) O[r(c)]=co; if(!b(p(co))) O[c]=r(co); if(!b(p(co))) O[r(co)]=c; O[p(c)]=p(co); O[p(co)]=p(c);  }
 
//  ==========================================================  SIMPLIFICATION  ===========================================
public void collapse() {collapse(c);}
public void collapse(int c) {if (b(c)) return;      // collapse edge opposite to corner c, does not check anything !!! assumes manifold
   int b=n(c), oc=o(c), vpc=v(p(c));
   visible[t(c)]=false; visible[t(oc)]=false;
   for (int a=b; a!=p(oc); a=n(l(a))) V[a]=vpc;
   O[l(c)]=r(c); O[r(c)]=l(c); O[l(oc)]=r(oc); O[r(oc)]=l(oc);  }

// ============================================================= COMPRESSION ============================================================
 boolean showEB=false, showEBrec=false;
 char[] triangleSymbol = new char[maxnt];
 char[] CLERS = new char[maxnt];
 int symbols=0;
 int stack[] = new int[10000];
 int stackHeight=1;
 int Ccount=0, Lcount=0, Ecount=0, Rcount=0, Scount=0;
 boolean EBisDone;
 int firstCorner=0; 
 int step=1;                              // to do something step by step

 public void showEB() {
      for(int t=0; t<nt; t++) {fill(cyan);
         if (triangleSymbol[t]=='w') {fill(white);};
         if (triangleSymbol[t]=='B') {fill(black);};
         if (triangleSymbol[t]=='C') {fill(yellow);};
         if (triangleSymbol[t]=='L') {fill(blue);};
         if (triangleSymbol[t]=='E') {fill(magenta);};
         if (triangleSymbol[t]=='R') {fill(orange);};
         if (triangleSymbol[t]=='S') {fill(red);};
         shade(t); 
         }
      }  
 
public void EBcompress(int c) {
 Ccount=0; Lcount=0; Ecount=0; Rcount=0; Scount=0; 
 resetStack(); 
 for (int v=0; v<nv; v++) {VisitedV[v]=false;};
 for (int t=0; t<nt; t++) {VisitedT[t]=false;};
 VisitedT[t(c)]=true; triangleSymbol[t(c)]='B'; VisitedV[v(c)]=true; VisitedV[v(n(c))]=true; VisitedV[v(p(c))]=true; c=r(c);
 symbols=0; 
 boolean EBisDone=false;
 while (!EBisDone) {
  VisitedT[t(c)]=true; 
  if (!VisitedV[v(c)]) {triangleSymbol[t(c)]='C'; Ccount++; CLERS[symbols++]=triangleSymbol[t(c)]; VisitedV[v(c)]=true; c=r(c); }
  else {
    if (VisitedT[t(r(c))]) {
        if (VisitedT[t(l(c))]) {triangleSymbol[t(c)]='E'; Ecount++; CLERS[symbols++]=triangleSymbol[t(c)]; c=stack[--stackHeight]; if (stackHeight==0) {EBisDone=true;};}
        else {triangleSymbol[t(c)]='R'; Rcount++; CLERS[symbols++]=triangleSymbol[t(c)]; c=l(c);};
       }
    else {
        if (VisitedT[t(l(c))]) {triangleSymbol[t(c)]='L'; Lcount++; CLERS[symbols++]=triangleSymbol[t(c)]; c=r(c);}
        else {triangleSymbol[t(c)]='S'; triangleSymbol[t(l(c))]='w'; Scount++; CLERS[symbols++]=triangleSymbol[t(c)]; stack[stackHeight++]=l(c); c=r(c);};
      };
    };
  }; 
  int total=Ccount+Lcount+Ecount+Rcount+Scount;
  println(nt+" triangles, "+total+" symbols: C="+Ccount+", L="+Lcount+", E="+Ecount+", R="+Rcount+", S="+Scount);
 }

public int pop() {if (stackHeight==0){ println("Stack is empty"); stackHeight=1;}; return(stack[--stackHeight]);}
public void push(int c) {stack[stackHeight++]=c; }
public void resetStack() {stackHeight=1;};

public void EBinit() {
   for (int v=0; v<nv; v++) {VisitedV[v]=false;};
   for (int t=0; t<nt; t++) {VisitedT[t]=false;};
   VisitedT[t(c)]=true; triangleSymbol[t(c)]='B'; VisitedV[v(c)]=true; VisitedV[v(n(c))]=true; VisitedV[v(p(c))]=true; c=r(c);
   symbols=0; EBisDone=false;
   }
   
public void EBmove() {
 if (!EBisDone) {
  VisitedT[t(c)]=true; 
  if (!VisitedV[v(c)]) {triangleSymbol[t(c)]='C'; Ccount++; CLERS[symbols++]=triangleSymbol[t(c)]; VisitedV[v(c)]=true; c=r(c); }
  else {
    if (VisitedT[t(r(c))]) {
        if (VisitedT[t(l(c))]) {triangleSymbol[t(c)]='E'; Ecount++; CLERS[symbols++]=triangleSymbol[t(c)]; c=stack[--stackHeight]; if (stackHeight==0) {EBisDone=true;};}
        else {triangleSymbol[t(c)]='R'; Rcount++; CLERS[symbols++]=triangleSymbol[t(c)]; c=l(c);};
       }
    else {
        if (VisitedT[t(l(c))]) {triangleSymbol[t(c)]='L'; Lcount++; CLERS[symbols++]=triangleSymbol[t(c)]; c=r(c);}
        else {triangleSymbol[t(c)]='S'; triangleSymbol[t(l(c))]='w'; Scount++; CLERS[symbols++]=triangleSymbol[t(c)]; stack[stackHeight++]=l(c); c=r(c);};
      };
    };
   print(symbols+":"+CLERS[symbols-1]+" ");
  } else {print(".");};
 }
 
public void EBjump() {
  int t=t(c);
  if (triangleSymbol[t]=='B') {c=r(c);};
  if (triangleSymbol[t]=='C') {c=r(c);};
  if (triangleSymbol[t]=='L') {c=r(c);};
  if (triangleSymbol[t]=='E') {c=pop();};
  if (triangleSymbol[t]=='R') {c=l(c);};
  if (triangleSymbol[t]=='S') {push(l(c)); c=r(c);};
  }

public void EBshow(int c, pt nV, pt pV) {
  fill(yellow);
  int t=t(c);
  pt tV = g(c).make();
  if (triangleSymbol[t]=='B') {fill(200,200,200);tV.moveTowards(0.07f,nV);};
  if (triangleSymbol[t]=='C') {fill(90,250,200); tV.moveTowards(0.07f,nV);};
  if (triangleSymbol[t]=='L') {fill(20,250,250);};
  if (triangleSymbol[t]=='E') {fill(155,250,150); tV.moveTowards(0.05f,pV); tV.moveTowards(0.05f,nV);};
  if (triangleSymbol[t]=='R') {fill(127,250,200);};
  if (triangleSymbol[t]=='S') {fill(255,250,150); tV.moveTowards(0.05f,pV); tV.moveTowards(0.05f,nV);};
  beginShape(TRIANGLES);  nV.vert();   pV.vert();  tV.vert(); endShape(); 
  if (triangleSymbol[t]=='B') {EBshow(r(c),nV,tV);};
  if (triangleSymbol[t]=='C') {EBshow(r(c),nV,tV);};
  if (triangleSymbol[t]=='L') { EBshow(r(c),nV,tV);};
  if (triangleSymbol[t]=='E') { };
  if (triangleSymbol[t]=='R') { EBshow(l(c),tV,pV);};
  if (triangleSymbol[t]=='S') { EBshow(r(c),nV,tV); EBshow(l(c),tV,pV);};
  };

public void EBprint(int c) {
   int t=t(c);
   print(triangleSymbol[t]); CLERS[symbols++]=triangleSymbol[t(c)]; 
  if (triangleSymbol[t]=='B') {EBprint(r(c));};
  if (triangleSymbol[t]=='C') {EBprint(r(c));};
  if (triangleSymbol[t]=='L') {EBprint(r(c));};
  if (triangleSymbol[t]=='E') { };
  if (triangleSymbol[t]=='R') {EBprint(l(c));};
  if (triangleSymbol[t]=='S') {EBprint(r(c)); EBprint(l(c));};
  };

public void EBprintS(int pc) {
 int c=pc; 
 symbols=0;
 resetStack();
 boolean EBisDone=false;
 while (!EBisDone) {
   int t=t(c);
//   print(triangleSymbol[t]); 
   CLERS[symbols++]=triangleSymbol[t(c)]; 
  if (triangleSymbol[t]=='B') {c=r(c);};
  if (triangleSymbol[t]=='C') {c=r(c);};
  if (triangleSymbol[t]=='L') {c=r(c);};
  if (triangleSymbol[t]=='E') {c=pop(); if (stackHeight==0) {EBisDone=true;}};
  if (triangleSymbol[t]=='R') {c=l(c);};
  if (triangleSymbol[t]=='S') {push(r(c)); c=l(c);};
   };
 };

public int leadingCS() { int r = 1; while (CLERS[r]=='C') {r++;};  return(r);};

public void EBstats(int lCs) {
 int cc=0, cl=0, ce=0, cr=0, cs=0, ct=0; 
 int lc=0, ll=0, le=0, lr=0, ls=0, lt=0; 
 int ec=0, el=0, ee=0, er=0, es=0, et=0; 
 int rc=0, rl=0, re=0, rr=0, rs=0, rt=0; 
 int sc=0, sl=0, se=0, sr=0, ss=0, st=0; 
 char last='C';
  println("    The "+lCs+" leading Cs are not counted and replaced by an overhead of "+PApplet.parseInt(log2(lCs))+" bits");
 for (int i=lCs; i<symbols; i++) {
   char s=CLERS[i];    print(s);
   if (last=='C') {if(s=='C') {cc++;}; if(s=='L') {cl++;}; if(s=='E') {ce++;}; if(s=='R') {cr++;}; if(s=='S') {cs++;}; };
   if (last=='L') {if(s=='C') {lc++;}; if(s=='L') {ll++;}; if(s=='E') {le++;}; if(s=='R') {lr++;}; if(s=='S') {ls++;}; };
   if (last=='E') {if(s=='C') {ec++;}; if(s=='L') {el++;}; if(s=='E') {ee++;}; if(s=='R') {er++;}; if(s=='S') {es++;}; };
   if (last=='R') {if(s=='C') {rc++;}; if(s=='L') {rl++;}; if(s=='E') {re++;}; if(s=='R') {rr++;}; if(s=='S') {rs++;}; };
   if (last=='S') {if(s=='C') {sc++;}; if(s=='L') {sl++;}; if(s=='E') {se++;}; if(s=='R') {sr++;}; if(s=='S') {ss++;}; };
   last=s;
   };
  println();
  print("symbols reduced from "+symbols);  int rsymbols=symbols-lCs;  println(" to "+rsymbols);
  ct=cc+lc+ec+rc+sc;
  lt=cl+ll+el+rl+sl;
  et=ce+le+ee+re+se;
  rt=cr+lr+er+rr+sr;
  st=cs+ls+es+rs+ss;
  
  float Cf=PApplet.parseFloat(ct)/rsymbols, Lf=PApplet.parseFloat(lt)/rsymbols, Ef=PApplet.parseFloat(et)/rsymbols, Rf=PApplet.parseFloat(rt)/rsymbols, Sf=PApplet.parseFloat(st)/rsymbols;
  float entropy = -( log2(Cf)*Cf + log2(Lf)*Lf + log2(Ef)*Ef + log2(Rf)*Rf + log2(Sf)*Sf ); 
   println("100*Frequencies: C="+nf(Cf*100,2,2)+", L="+nf(Lf*100,2,2)+", E="+nf(Ef*100,2,2)+", R="+nf(Rf*100,2,2)+", S="+nf(Sf*100,2,2));
   println("***   Entropy (over remaining symbols ) = "+nf(entropy,1,2));
  println();
  println("COUNTS for "+rsymbols+" CLERS symbols:");
  println("        COUNTS cc="+nf(cc,4)+",  lc="+nf(lc,4)+",  ec="+nf(ec,4)+",  rc="+nf(rc,4)+",  sc="+nf(sc,4)+" .c="+nf(ct,4)); 
  println("        COUNTS cl="+nf(cl,4)+",  ll="+nf(ll,4)+",  el="+nf(el,4)+",  rl="+nf(rl,4)+",  sl="+nf(sl,4)+" .l="+nf(lt,4)); 
  println("        COUNTS ce="+nf(ce,4)+",  le="+nf(le,4)+",  ee="+nf(ee,4)+",  re="+nf(re,4)+",  se="+nf(se,4)+" .e="+nf(et,4)); 
  println("        COUNTS cr="+nf(cr,4)+",  lr="+nf(lr,4)+",  er="+nf(er,4)+",  rr="+nf(rr,4)+",  sr="+nf(sr,4) +" .r="+nf(rt,4)); 
  println("        COUNTS cs="+nf(cs,4)+",  ls="+nf(ls,4)+",  es="+nf(es,4)+",  rs="+nf(rs,4)+",  ss="+nf(ss,4) +" .s="+nf(st,4)); 
  float cost = entropy*rsymbols;   float costWlcs = cost+PApplet.parseInt(log2(lCs));
  float e = cost/(symbols);   float eWlcs = costWlcs/(symbols); 
  println("***  Amortized over all symbols :");
  println("*** No-context:                 Entropy = "+nf(e,1,2)+" bpt. Total cost = "+nf(cost,6,2)+" bits");
  println("*** counting RLE of leading Cs: Entropy = "+nf(eWlcs,1,2)+" bpt. Total cost = "+nf(costWlcs,6,2)+" bits");

  println("Pairs frequencies:");
  println("        COUNTS cc="+nf(PApplet.parseFloat(cc)/rsymbols,1,4)+",  lc="+nf(PApplet.parseFloat(lc)/rsymbols,1,4)+",  ec="+nf(PApplet.parseFloat(ec)/rsymbols,1,4)+",  rc="+nf(PApplet.parseFloat(rc)/rsymbols,1,4)+",  sc="+nf(PApplet.parseFloat(sc)/rsymbols,1,4)+" .c="+nf(PApplet.parseFloat(ct)/rsymbols,1,4)); 
  println("        COUNTS cl="+nf(PApplet.parseFloat(cl)/rsymbols,1,4)+",  ll="+nf(PApplet.parseFloat(ll)/rsymbols,1,4)+",  el="+nf(PApplet.parseFloat(el)/rsymbols,1,4)+",  rl="+nf(PApplet.parseFloat(rl)/rsymbols,1,4)+",  sl="+nf(PApplet.parseFloat(sl)/rsymbols,1,4)+" .l="+nf(PApplet.parseFloat(lt)/rsymbols,1,4)); 
  println("        COUNTS ce="+nf(PApplet.parseFloat(ce)/rsymbols,1,4)+",  le="+nf(PApplet.parseFloat(le)/rsymbols,1,4)+",  ee="+nf(PApplet.parseFloat(ee)/rsymbols,1,4)+",  re="+nf(PApplet.parseFloat(re)/rsymbols,1,4)+",  se="+nf(PApplet.parseFloat(se)/rsymbols,1,4)+" .e="+nf(PApplet.parseFloat(et)/rsymbols,1,4)); 
  println("        COUNTS cr="+nf(PApplet.parseFloat(cr)/rsymbols,1,4)+",  lr="+nf(PApplet.parseFloat(lr)/rsymbols,1,4)+",  er="+nf(PApplet.parseFloat(er)/rsymbols,1,4)+",  rr="+nf(PApplet.parseFloat(rr)/rsymbols,1,4)+",  sr="+nf(PApplet.parseFloat(sr)/rsymbols,1,4) +" .r="+nf(PApplet.parseFloat(rt)/rsymbols,1,4)); 
  println("        COUNTS cs="+nf(PApplet.parseFloat(cs)/rsymbols,1,4)+",  ls="+nf(PApplet.parseFloat(ls)/rsymbols,1,4)+",  es="+nf(PApplet.parseFloat(es)/rsymbols,1,4)+",  rs="+nf(PApplet.parseFloat(rs)/rsymbols,1,4)+",  ss="+nf(PApplet.parseFloat(ss)/rsymbols,1,4) +" .s="+nf(PApplet.parseFloat(st)/rsymbols,1,4)); 


  ct=cc+cl+ce+cr+cs;
  lt=lc+ll+le+lr+ls;
  et=ec+el+ee+er+es;
  rt=rc+rl+re+rr+rs;
  st=sc+sl+se+sr+ss;

  println();
  float ccf=0, clf=0, cef=0, crf=0, csf=0;
  float lcf=0, llf=0, lef=0, lrf=0, lsf=0;
  float ecf=0, elf=0, eef=0, erf=0, esf=0;
  float rcf=0, rlf=0, ref=0, rrf=0, rsf=0;
  float scf=0, slf=0, sef=0, srf=0, ssf=0;
  
  if (ct!=0) {  ccf=PApplet.parseFloat(cc)/ct; clf=PApplet.parseFloat(cl)/ct; cef=PApplet.parseFloat(ce)/ct; crf=PApplet.parseFloat(cr)/ct; csf=PApplet.parseFloat(cs)/ct; };
  if (lt!=0) {  lcf=PApplet.parseFloat(lc)/lt; llf=PApplet.parseFloat(ll)/lt; lef=PApplet.parseFloat(le)/lt; lrf=PApplet.parseFloat(lr)/lt; lsf=PApplet.parseFloat(ls)/lt; };
  if (et!=0) {  ecf=PApplet.parseFloat(ec)/et; elf=PApplet.parseFloat(el)/et; eef=PApplet.parseFloat(ee)/et; erf=PApplet.parseFloat(er)/et; esf=PApplet.parseFloat(es)/et; };
  if (rt!=0) {  rcf=PApplet.parseFloat(rc)/rt; rlf=PApplet.parseFloat(rl)/rt; ref=PApplet.parseFloat(re)/rt; rrf=PApplet.parseFloat(rr)/rt; rsf=PApplet.parseFloat(rs)/rt; };
  if (st!=0) {  scf=PApplet.parseFloat(sc)/st; slf=PApplet.parseFloat(sl)/st; sef=PApplet.parseFloat(se)/st; srf=PApplet.parseFloat(sr)/st; ssf=PApplet.parseFloat(ss)/st; };
  
  println("  Context frequencies");
  println("        % cc="+nf(ccf,0,2)+",  lc="+nf(lcf,0,2)+",  ec="+nf(ecf,0,2)+",  rc="+nf(rcf,0,2)+",  sc="+nf(scf,0,2)); 
  println("        % cl="+nf(clf,0,2)+",  ll="+nf(llf,0,2)+",  el="+nf(elf,0,2)+",  rl="+nf(rlf,0,2)+",  sl="+nf(slf,0,2)); 
  println("        % ce="+nf(cef,0,2)+",  le="+nf(lef,0,2)+",  ee="+nf(eef,0,2)+",  re="+nf(ref,0,2)+",  se="+nf(sef,0,2)); 
  println("        % cr="+nf(crf,0,2)+",  lr="+nf(lrf,0,2)+",  er="+nf(erf,0,2)+",  rr="+nf(rrf,0,2)+",  sr="+nf(srf,0,2)); 
  println("        % cs="+nf(csf,0,2)+",  ls="+nf(lsf,0,2)+",  es="+nf(esf,0,2)+",  rs="+nf(rsf,0,2)+",  ss="+nf(ssf,0,2)); 
  println();
   
  float cE = -( log2(ccf)*ccf + log2(clf)*clf + log2(cef)*cef + log2(crf)*crf + log2(csf)*csf ) ; 
  float lE = -( log2(lcf)*lcf + log2(llf)*llf + log2(lef)*lef + log2(lrf)*lrf + log2(lsf)*lsf ) ; 
  float eE = -( log2(ecf)*ecf + log2(elf)*elf + log2(eef)*eef + log2(erf)*erf + log2(esf)*esf ) ; 
  float rE = -( log2(rcf)*rcf + log2(rlf)*rlf + log2(ref)*ref + log2(rrf)*rrf + log2(rsf)*rsf ) ; 
  float sE = -( log2(scf)*scf + log2(slf)*slf + log2(sef)*sef + log2(srf)*srf + log2(ssf)*ssf ) ; 
  
  println("    Stream entropies: after C="+nf(cE,1,2)+", after L="+nf(lE,1,2)+", after E="+nf(eE,1,2)+", after R="+nf(rE,1,2)+", after S="+nf(sE,1,2));
  println("    Frequencies:            C="+nf(Cf,1,2)+",       L="+nf(Lf,1,2)+",       E="+nf(Ef,1,2)+",       R="+nf(Rf,1,2)+",       S="+nf(Sf,1,2));
  float Centropy=cE*Cf+lE*Lf+eE*Ef+rE*Rf+sE*Sf;
  cost = Centropy*rsymbols;    costWlcs = cost+PApplet.parseInt(log2(lCs));
  e = cost/symbols;    eWlcs = costWlcs/symbols; 
  println("***   Entropy (over remaining symbols ) = "+nf(Centropy,1,2));
  println("***  Amortized over all symbols :");
  println("*** Average context Entropy = "+nf(Centropy,1,2)+" bpt. Total cost = "+nf(Centropy*symbols,6,2)+" bits");
  println("*** Ccontext:                   Entropy = "+nf(e,1,2)+" bpt. Total cost = "+nf(cost,6,2)+" bits");
  println("*** counting RLE of leading Cs: Entropy = "+nf(eWlcs,1,2)+" bpt. Total cost = "+nf(costWlcs,6,2)+" bits");
  println("+++++++++++++++++++++++++++++++++++++++++++++");
  }
 public void triangulate() {     // performs Delaunay triangulation using a quartic algorithm
   // Remove all triangles
   for (int t = 0; t < nt; t++)
     visible[t] = false;
   excludeInvisibleTriangles();
   compactVO();
   
   c=0;                   // to reset current corner
   pt X = new pt(0,0,0);
   float r=1;
   for (int i=0; i<nv; i++){G[i].z=0;}
   for (int i=0; i<nv-2; i++) for (int j=i+1; j<nv-1; j++) for (int k=j+1; k<nv; k++) {
      X=circumCenter (G[i],G[j],G[k]);  r = X.disTo(G[i]);
      boolean found=false; 
      for (int m=0; m<nv; m++) if ((m!=i)&&(m!=j)&&(m!=k)&&(X.disTo(G[m])<=r)) found=true;  
     if (!found) {if (ccw(G[i],G[j],G[k])) addTriangle(i,j,k); else addTriangle(i,k,j);};
     }; 
   }
 
 public void showTriangles2D() {
   stroke(orange);
   noFill();
   beginShape(TRIANGLES);     
     for (int i = 0; i < nc; i++)
         g(i).v();
   endShape();
 }
 
 public void laplace2D(float s) {
   this.laplace2DHelp(s);
   this.laplace2DHelp(-s);
 }
 
 public void laplace2DHelp(float s) {
   boolean[] taggedC = new boolean[nc];
   pt[] vPrimes = new pt[nv];
   
   // We perform it for each interior vertex
   for (int c = 0; c < nc; c++) {
     // If already visited, continue
     if (taggedC[c])
       continue;
     
     taggedC[c] = true;
     
     // Two cases, one for with a border, one for without
     if (!mirrored) {
       // Test for interior, which means swing will always produce same vertex index
       int v = v(c);
       int next = c;
       ArrayList neighbors = new ArrayList();
       neighbors.add((Integer)c);
       while ((next = s(next)) != c) {
         // If not the same vertex (or already visited), not an interior corner
         if (v(next) != v || taggedC[next])
           break;
       
         // We are swinging, let's tag and add
         taggedC[next] = true;
         neighbors.add((Integer)next);
       
         // If beginning is next, we have an interior, do laplace
         if (s(next) == c) {
           // Get the midpoints and their weights
           ArrayList mids = new ArrayList();
           ArrayList midsW = new ArrayList();
           for (int j = 0; j < neighbors.size(); j++) {
             int corner = (Integer)neighbors.get(j);
             // Get points
             pt2D a = new pt2D(g(n(corner)).x, g(n(corner)).y);
             pt2D b = new pt2D(g(p(corner)).x, g(p(corner)).y);
             // Get and store the midpoint
             mids.add(A2D(a, b));
             // Get and store the weight (length) of edge
             midsW.add((Float)a.disTo(b));
           }
         
           // Calculate the V' (weighted average)
           float totalW = 0;
           for (int i = 0; i < midsW.size(); i++)
             totalW += (Float)midsW.get(i);
           pt2D vPrime = ((pt2D)mids.get(0)).scaleBy((Float)midsW.get(0));
           for (int i = 1; i < mids.size(); i++)
             vPrime.addScaledPt((Float)midsW.get(i), (pt2D)mids.get(i));
           vPrime.scaleBy(1.0f/totalW);
         
           // Save V'
           vPrimes[v] = new pt(vPrime.x, vPrime.y, G[v].z);
         }
       }
     }
     else {
       // Test for interior, which means that it's z = 0;
       if (M.g(c).z == 0)
         continue;
     
       int v = v(c);
       int next = c;
       ArrayList neighbors = new ArrayList();
       neighbors.add((Integer)c);
       while ((next = s(next)) != c) {
         // We are swinging, let's tag and add
         taggedC[next] = true;
         neighbors.add((Integer)next);
       }

       // Do laplace
       // Get the midpoints and their weights
       ArrayList mids = new ArrayList();
       ArrayList midsW = new ArrayList();
       for (int j = 0; j < neighbors.size(); j++) {
         int corner = (Integer)neighbors.get(j);
         // Get points
         pt2D a = new pt2D(g(n(corner)).x, g(n(corner)).y);
         pt2D b = new pt2D(g(p(corner)).x, g(p(corner)).y);
         // Get and store the midpoint
         mids.add(A2D(a, b));
         // Get and store the weight (length) of edge
         midsW.add((Float)a.disTo(b));
       }
         
       // Calculate the V' (weighted average)
       float totalW = 0;
       for (int i = 0; i < midsW.size(); i++)
         totalW += (Float)midsW.get(i);
       pt2D vPrime = ((pt2D)mids.get(0)).scaleBy((Float)midsW.get(0));
       for (int i = 1; i < mids.size(); i++)
         vPrime.addScaledPt((Float)midsW.get(i), (pt2D)mids.get(i));
       vPrime.scaleBy(1.0f/totalW);
         
       // Save V'
       vPrimes[v] = new pt(vPrime.x, vPrime.y, G[v].z);
     }
   }
   
   // Go through points in mesh and apply smoothing
   for (int i = 0; i < nv; i++) {
     // If the vPrimes at this index is not null, apply smoothing
     if (vPrimes[i] != null)
       G[i].addVec(V(G[i], vPrimes[i]).mul(s));
   }
 }
 
 public void showCorner2D(int c, int r) {
   pt cPt = midPt(g(c),midPt(g(c),corner(c)));
   pt2D p = new pt2D(cPt.x, cPt.y);
   p.show(r);
 }
 
 public void show2D() {
  showTriangles2D();
  noStroke(); fill(dblue); showCorner2D(c,PApplet.parseInt(2*r));  
 }
   
  } // ==== END OF MESH CLASS
  
public float log2(float x) {float r=0; if (x>0.00001f) { r=log(x) / log(2);} ; return(r);}
vec labelD=new vec(-4,+4, 12);           // offset vector for drawing labels
int maxr=1;
pt2D pickedPoint = P2D();
int vc=64, kc=1;             // vertex and keyframe counts
int k=0;                     // current key frame
Polyloop [] CP= new Polyloop [kc];  // control polyloops
//Polyloop C= new Polyloop();  // used to cut and paste
Polyloop P= new Polyloop();  // reference for editing
Polyloop D= new Polyloop();  // used to capture the curve drawn by the user
pt2D[] Tc; // list of triangle centers
float[] TcR; // raidus for triangle center disk
boolean showKeys=false;          // toggle show all keys
boolean showMouseProjection=false;          // toggle show mouse projection
boolean sketching=false;     // toggle indicating that the user is sketching the selected curve
boolean showVertices=true;   // show control vertices
boolean showEkey=true;    // show edited curve
boolean mat = false;     // show the medial axis transform
boolean matDisks = false;    // show the MAT disks
boolean meshMode = false;   // if true show mesh, else show polyloop
boolean spinAnimation = false;   // if true do spin animation, else dont do anything
float spinAnimCounter=0;                   // current time for animation
float leftmostVertValue=0; //when rotating around y-axis
float rightmostVertValue=0; //when rotating around y-axis   
float distanceFromVertVals=0; //when rotating around y-axis
float t=0;                   // current time for animation
int sprayNum = 50;
boolean coolSpray = false;
int[] O2D = new int[vc];    // 2D opposite table (related to mirror)
ArrayList MAT = new ArrayList();
boolean mirrored = false;
boolean matMin = true;
boolean matMax = false;
boolean matAverage = false;

public void myInit() {for(int i=0; i<kc; i++) CP[i]=new Polyloop(); myReset(); mySelected(0); myLoad(); loopToMesh(); bulge();}
public void myReset() {for(int i=0; i<kc; i++) CP[i].reset(vc);};
public void mySave() {for(int i=0; i<kc; i++) CP[i].savePts(i);}; 
public void myLoad() {for(int i=0; i<kc; i++) CP[i].loadPts(i);}; 
public void myDenoise() {P.smoothen(5);}
public void mySample() {P.resample(vc);}
public void myRefine() {P.refine(0,0); vc=P.vn;}
//void myCopy() {C.setTo(CP[k]);}
//void myPaste() {CP[k].setTo(C);}
   
public void mySelected(int n) {k=n; P=CP[k];}     // user selects curve by typing its number n: select curve
public void myStartAcquisition() {D.empty(); D.appendPt(Mouse2D()); sketching=true; }  // start acquisition processd
public void myEndAcquisition() {if(sketching) {D.smoothen(5); for(int i=0; i<4; i++); D.refine(0,0); D.smoothen(10); D.resample(vc); P.setTo(D); sketching=false;}; }      // finish acquisition process
public void myMousePressed() {
   if (Mouse2D().isInWindow()&&!keyPressed&&!sketching) pickedPoint=P.pickPoint(); 
   else if (Mouse2D().isInWindow()&&keyPressed&&(key=='d')) myStartAcquisition(); 
   } 
public void myMouseReleased() {pickedPoint=null; myEndAcquisition();}
public void myScale() {P.scaleWithMouse();}  
public void myTranslate() {P.translateWithMouse();}
public void myRotate() {P.rotateWithMouse();}

public void myActions() { // actions to be executed at each frame
   //scribe("Polygon or image morphing: Template for class projects Jarek Rossignac");   
   //if(animate) scribe("Animating",2);               
   if (!meshMode) {
     // Set up the view correctly (from 3D to 2D)
     camera(); perspective(); /*translate(-290,-290,0);*/ /*scale(1.7,1.7,1.0);*/
     
     if((mousePressed)&&!keyPressed) {if(pickedPoint!=null) pickedPoint.trackMouse(); };
     if((mousePressed)&&keyPressed) {if(key=='w') myTranslate(); if(key=='e') myRotate(); if(key=='z') myScale(); if(key=='d') D.extendToMouse();};
     //if(showKeys) {stroke(metal); noFill(); for(int i=0; i<kc; i++) CP[i].drawSmooth(0,5); fill(metal); for(int i=0; i<kc; i++) CP[i].rP(0).showLabel(i); noFill();}; // show all keys
     if(sketching) {stroke(dred,50); noFill(); P.drawSmooth(0,5); fill(red,50); P.rP(0).show(4); fill(yellow,50); P.rP(1).show(3); stroke(red); noFill(); D.drawOpen(); noStroke();}
     if (showEkey) {stroke(red);  if(!sketching) fill(yellow); P.drawCurve(); fill(white); if(showVertices) {P.showVertices(); fill(red); P.rP(0).show(4); fill(yellow); P.rP(1).show(3);} };
     if(showMouseProjection) P.showMouseProjection(0,5);  // show closest point on P to mouse green if mouse is inside and red otherwise
     /*if(animate) {t++; if (t>=kc*vc) t=0; 
        stroke(red);  fill(yellow); CP[int(t/vc)].drawSmooth(0,5);  // Default style: jumps from frame to frame (stroboscopic)
       };*/
     M.show2D();
     if (matDisks) {
       noStroke();
       // Show disks
       for (int i = 0; i < Tc.length; i++) {
         fill(orange, 75);
         ellipse(Tc[i].x, Tc[i].y, TcR[i]*2, TcR[i]*2);
       }
       // Show triangle centers
       for (int i = 0; i < Tc.length; i++) {
         fill(blue);
         Tc[i].show();
       }
     }
     if(mat) {
       stroke(blue);
       for (int i = 0; i < MAT.size(); i++)
         line((Float)((ArrayList)MAT.get(i)).get(0), (Float)((ArrayList)MAT.get(i)).get(1), (Float)((ArrayList)MAT.get(i)).get(2), (Float)((ArrayList)MAT.get(i)).get(3));
     }
   }
   
   if (meshMode) {
     perspective(PI/2.0f,width/height,1.0f,6.0f*Rbox);
     lights(); directionalLight(0,0,128,0,1,0); directionalLight(0,0,128,0,0,1);
     //translate(float(height)/2, float(height)/2, 0.0);     // center view wrt window  
     if ((!keyPressed)&&(mousePressed)) {C.pan(); C.pullE(); };
     if ((keyPressed)&&(mousePressed)) {updateView();}; 
     C1.track(C); C2.track(C1); C2.apply();
     M.show();
     /*pushMatrix();
     fill(red);
     translate(M.g(M.o(M.c)).x, M.g(M.o(M.c)).y, M.g(M.o(M.c)).z);
     sphere(5);
     popMatrix();*/
   }
   
   // debug
   if (printIt) {
     
   }
}


public void triangleSplitIntoFour(pt2D v0, pt2D v1, pt2D v2){
    pt2D Midpoint1 = new pt2D(A2D(v0,v1));
    pt2D Midpoint2 = new pt2D(A2D(v0,v2));
    pt2D Midpoint3 = new pt2D(A2D(v1,v2));

    pt2D CenterOrigTri = centerOfTriangle(v0,v1,v2);
    pt2D CenterNewTri1 = new pt2D(centerOfTriangle(v0,Midpoint1,Midpoint2));    
    pt2D CenterNewTri2 = new pt2D(centerOfTriangle(Midpoint1,v1,Midpoint3));    
    pt2D CenterNewTri3 = new pt2D(centerOfTriangle(Midpoint2,Midpoint3,v2));
    //println("happy");
    M.addVertex(new pt(CenterOrigTri.x, CenterOrigTri.y, 0));    
    M.addVertex(new pt(CenterNewTri1.x, CenterNewTri1.y, 0));
    M.addVertex(new pt(CenterNewTri2.x, CenterNewTri2.y, 0));
    M.addVertex(new pt(CenterNewTri3.x, CenterNewTri3.y, 0));
    
    //line(CenterNewTri1.x, CenterNewTri1.y,CenterNewTri2.x, CenterNewTri2.y);
    //line(CenterNewTri1.x, CenterNewTri1.y,CenterNewTri3.x, CenterNewTri3.y);
    //line(CenterNewTri2.x, CenterNewTri2.y,CenterNewTri3.x, CenterNewTri3.y);
}

public pt2D centerOfTriangle(pt2D v0, pt2D v1, pt2D v2){
    //float A=v0.triArea(v1,v2);
    float a=v1.disTo(v2);
    float b=v2.disTo(v0);
    float c=v0.disTo(v1);
    float s=a+b+c;
    pt2D bary = weightedSum((s-a)/2/s,v0,(s-b)/2/s,v1,(s-c)/2/s,v2);
    return bary;
    // Compute and store distance from point to vertices (radius of disk)
    /*USED THIS ONE*///TcR[i] = min(bary.disTo(v0), bary.disTo(v1), bary.disTo(v2));  
}  
/*
 * Take the current polyloop, put it in a mesh, and triangulate
 */
 
 //****************************//
 
public void loopToMesh() {
  mySample();
  M.importPolyloop(P);
  M.triangulate();
  M.update();
  
  // Computer center of each triangle
  /*Tc = new pt2D[M.nt];
  TcR = new float[M.nt];
  for (int i = 0; i < M.nt; i++) {
    pt2D v0 = new pt2D(M.g(3*i).x, M.g(3*i).y);
    pt2D v1 = new pt2D(M.g(3*i+1).x, M.g(3*i+1).y);
    pt2D v2 = new pt2D(M.g(3*i+2).x, M.g(3*i+2).y);
    Tc[i] = centerOfTriangle(v0,v1,v2);
    TcR[i] = min(Tc[i].disTo(v0), Tc[i].disTo(v1), Tc[i].disTo(v2));
  }*/
  
  // Get rid of triangles whose center is outside the polyloop
  clipTriangles();
  /*for (int i = 0; i < M.nt; i++) {
    boolean crossVert;
    pt2D A;
    pt2D B = Tc[i];
    vec2D AB;
    
    // Pick a line segment AB that is formed from the triangle center to a point outside the screen that does not cross a vertex
    do {
      // Pick random point outside the screen
      A = new pt2D(int(random(-myWidth, -1)), int(random(-myHeight, -1)));
      // See if the line AB intersects with a vertex C
      crossVert = false;
      AB = V2D(A, B);
      for (int j = 0; j < M.nv; j++) {
        vec2D AC = V2D(A, P.P[j]);
        if (dot2D(R2D(AB),AC) == 0 && 0 < dot2D(AB,AC) && dot2D(AB,AC) < dot2D(AB,AB))
          crossVert = true;
      }
    } while(crossVert);
    
    // Count the number of times the chosen line crosses an edge of the polyloop
    int numCrosses = 0;
    for (int j = 0; j < P.vn; j++)
    {
      if (edgesCross(A, B, P.P[j], P.P[P.n(j)]))
        numCrosses++;
    }
    
    // If the edge count is even, get rid of triangle
    if (numCrosses % 2 == 0) {
      // Set triangle as not visible in mesh
      M.visible[i] = false;
      // Set place-holder point (for deletion) in center list
      Tc[i] = new pt2D(-1, -1);
    }
  }*/
  
  // Get rid of invisible triangles
  /*M.clean();
  // Clean up center list
  int j = 0;
  pt2D[] temp1 = new pt2D[M.nt];
  float[] temp2 = new float[M.nt];
  for (int i = 0; i < Tc.length; i++)
    if (Tc[i].x != -1 && Tc[i].y != -1) {
      temp1[j] = Tc[i];
      temp2[j++] = TcR[i];
    }
  Tc = temp1;
  TcR = temp2;*/
  
  // Computer center of each triangle
  Tc = new pt2D[M.nt];
  TcR = new float[M.nt];
  for (int i = 0; i < M.nt; i++) {
    pt2D v0 = new pt2D(M.g(3*i).x, M.g(3*i).y);
    pt2D v1 = new pt2D(M.g(3*i+1).x, M.g(3*i+1).y);
    pt2D v2 = new pt2D(M.g(3*i+2).x, M.g(3*i+2).y);
    Tc[i] = centerOfTriangle(v0,v1,v2);
    if (matMin)
      TcR[i] = min(Tc[i].disTo(v0), Tc[i].disTo(v1), Tc[i].disTo(v2));
    else if (matAverage)
      TcR[i] = (Tc[i].disTo(v0) + Tc[i].disTo(v1) + Tc[i].disTo(v2))/3;
    else if (matMax)
      TcR[i] = max(Tc[i].disTo(v0), Tc[i].disTo(v1), Tc[i].disTo(v2));
  }
  
  saveMAT();
  
  if (coolSpray)
    for (int i = 0; i < M.nt; i++) {
      stroke(white);
      pt2D v0 = new pt2D(M.g(3*i).x, M.g(3*i).y);
      pt2D v1 = new pt2D(M.g(3*i+1).x, M.g(3*i+1).y);
      pt2D v2 = new pt2D(M.g(3*i+2).x, M.g(3*i+2).y);
      triangleSplitIntoFour(v0,v1,v2);
    }
  else
    randomSpray();
    
  M.triangulate();
  M.update();
  clipTriangles();
  
}//end loopToMesh

/*
 * Generic method to remove triangles outside the polyloop.
 */
public void clipTriangles() {
  // Get rid of triangles whose center is outside the polyloop
  for (int i = 0; i < M.nt; i++) {
    boolean crossVert;
    pt2D A;
    pt2D v0 = new pt2D(M.g(3*i).x, M.g(3*i).y);
    pt2D v1 = new pt2D(M.g(3*i+1).x, M.g(3*i+1).y);
    pt2D v2 = new pt2D(M.g(3*i+2).x, M.g(3*i+2).y);
    pt2D B = centerOfTriangle(v0, v1, v2);
    vec2D AB;
    
    /*
    // Pick a line segment AB that is formed from the triangle center to a point outside the screen that does not cross a vertex
    do {
      // Pick random point outside the screen
      A = new pt2D(int(random(-myWidth, -1)), int(random(-myHeight, -1)));
      // See if the line AB intersects with a vertex C
      crossVert = false;
      AB = V2D(A, B);
      for (int j = 0; j < P.vn; j++) {
        vec2D AC = V2D(A, P.P[j]);
        if (dot2D(R2D(AB),AC) == 0 && 0 < dot2D(AB,AC) && dot2D(AB,AC) < dot2D(AB,AB))
          crossVert = true;
      }
    } while(crossVert);
    
    // Count the number of times the chosen line crosses an edge of the polyloop
    int numCrosses = 0;
    for (int j = 0; j < P.vn; j++)
    {
      if (edgesCross(A, B, P.P[j], P.P[P.n(j)]))
        numCrosses++;
    }
    
    // If the edge count is even, get rid of triangle
    if (numCrosses % 2 == 0) {
      // Set triangle as not visible in mesh
      M.visible[i] = false;
    }*/
    if (!insidePolyloop(B))
      M.visible[i] = false;
  }
  
  // Get rid of invisible triangles
  M.clean();
}

public void bulge() {
  mirrored = false;
  
  // Go through each vertex of the mesh
  for (int v = 0; v < M.nv; v++) {
    pt2D p = new pt2D(M.G[v].x, M.G[v].y);
    
    // In order for watertight-ness, we make sure any polyloop vertices (the originals on outside) have z = 0
    if (vertexInPolyloop(p.x, p.y)) {
      M.G[v].z = 0;
      continue;
    }
    
    // Go through each point on the MAT and save max height
    float h = 0;
    for (int m = 0; m < Tc.length; m++) {
      
      // Get the distance to MAT point
      float d = p.disTo(Tc[m]);
      
      // If d >= r, not inside circle or height is 0 anyway
      if (d >= TcR[m])
        continue;
      
      // Compute height
      float tempH = sqrt(sq(TcR[m]) - sq(d));
      
      // If height > h, then use it
      if (tempH > h)
        h = tempH;
    }
    
    // Set z-coordinate according to h
    M.G[v].z = h;
  }
  
  // Prepare for watertight mirror
  zip();
  
  // Initialize the view
  initView(M);
}

// Make all border points have a z of 0, so it zips together well for mirror
public void zip() {
  // Go through and if a vertex is a border one, make it's z = 0
  for (int c = 0; c < M.nc; c++)
    if (M.b(M.p(c)) || M.b(M.n(c)))
      // Yay, we have a border point
      M.g(c).z = 0;
}

public void mirror() {
  mirrored = true;
  
  // Duplicate vertices with -z
  // Take a snapshot of nv
  int tempNV = M.nv;
  // Number skipped (going to use for skipped array)
  int numSkipped = 0;
  int[] skippedArray = new int[tempNV];
  for (int v = 0; v < tempNV; v++) {
    // Do not add vertex if the z is 0 (we will share it)
    if (M.G[v].z != 0)
      M.addVertex(M.G[v].x, M.G[v].y, -M.G[v].z);
    else
      numSkipped++;
    skippedArray[v] = numSkipped;
  }
  
  // Initialize opposite table
  O2D = new int[M.nc*2];
  
  // Make mirror triangles
  // Take a snapshot of nt
  int tempNT = M.nt;
  for (int t = 0; t < tempNT; t++) {
    int v0 = M.v(3*t);
    int v1 = M.v(3*t+1);
    int v2 = M.v(3*t+2);
    // If a vertex is not an edge vertex (used for zipping), then calculate the duplicate index
    int temp;
    if (M.G[v0].z != 0) {
      v0 += tempNV-skippedArray[v0];
    }
    if (M.G[v1].z != 0) {
      v1 += tempNV-skippedArray[v1];
    }
    if (M.G[v2].z != 0) {
      v2 += tempNV-skippedArray[v2];
    }
    // Add in opposite order to get proper orientation
    M.addTriangle(v0, v2, v1);
    O2D[M.nc-3] = 3*t;
    O2D[M.nc-2] = 3*t+2;
    O2D[M.nc-1] = 3*t+1;
  }
  
  // Update mesh
  M.update();
}

public boolean vertexInPolyloop(float x, float y) {
  for (int i = 0; i < P.vn; i++)
    if (x == P.P[i].x && y == P.P[i].y)
      return true;
  
  // Not found
  return false;
}

public void randomSpray() {
  // Find min and max x and y to limit scope
  float maxX = 0;
  float minX = width;
  float maxY = 0;
  float minY = height;
  for (int i = 0; i < P.vn; i++) {
    if (P.P[i].x > maxX)
      maxX = P.P[i].x;
    if (P.P[i].x < minX)
      minX = P.P[i].x;
    if (P.P[i].y > maxY)
      maxY = P.P[i].y;
    if (P.P[i].y < minY)
      minY = P.P[i].y;
  }
  
  // Spray points
  pt2D p;
  for (int i = 0; i < sprayNum; i++) {
    // Get random point inside polyloop
    do {
      p = new pt2D (random(minX, maxX), random(minY, maxY));
    } while (!insidePolyloop(p));
    // Add it
    M.addVertex(p.x, p.y, 0);
  }
}

public boolean insidePolyloop(pt2D B) {
  pt2D A;
  boolean crossVert;
  vec2D AB;
  
  // Pick a line segment AB that is formed from the triangle center to a point outside the screen that does not cross a vertex
  do {
    // Pick random point outside the screen
    A = new pt2D(PApplet.parseInt(random(-myWidth, -1)), PApplet.parseInt(random(-myHeight, -1)));
    // See if the line AB intersects with a vertex C
    crossVert = false;
    AB = V2D(A, B);
    for (int j = 0; j < P.vn; j++) {
      vec2D AC = V2D(A, P.P[j]);
      if (dot2D(R2D(AB),AC) == 0 && 0 < dot2D(AB,AC) && dot2D(AB,AC) < dot2D(AB,AB))
        crossVert = true;
    }
  } while(crossVert);
  
  // Count the number of times the chosen line crosses an edge of the polyloop
  int numCrosses = 0;
  for (int j = 0; j < P.vn; j++)
  {
    if (edgesCross(A, B, P.P[j], P.P[P.n(j)]))
      numCrosses++;
  }
  
  // If the edge count is even, outside (not even, inside)
  return (numCrosses % 2 != 0);
}

public void saveMAT() {
  MAT.clear();
  
  int self;
  int opp;
  // Iterate through triangles
  for (int i = 0; i < Tc.length; i++) {
    // Draw line from triangle center to centers of any adjacent triangle centers
    if ((self = 3*i) != (opp = M.o(self))) {
      ArrayList temp = new ArrayList();
      temp.add((Float)Tc[M.t(self)].x);
      temp.add((Float)Tc[M.t(self)].y);
      temp.add((Float)Tc[M.t(opp)].x);
      temp.add((Float)Tc[M.t(opp)].y);
      MAT.add(temp);
      //line(Tc[M.t(self)].x, Tc[M.t(self)].y, Tc[M.t(opp)].x, Tc[M.t(opp)].y);
    }
    if ((self = 3*i+1) != (opp = M.o(self))) {
      ArrayList temp = new ArrayList();
      temp.add((Float)Tc[M.t(self)].x);
      temp.add((Float)Tc[M.t(self)].y);
      temp.add((Float)Tc[M.t(opp)].x);
      temp.add((Float)Tc[M.t(opp)].y);
      MAT.add(temp);
      //line(Tc[M.t(self)].x, Tc[M.t(self)].y, Tc[M.t(opp)].x, Tc[M.t(opp)].y);
    }
    if ((self = 3*i+2) != (opp = M.o(self))) {
      ArrayList temp = new ArrayList();
      temp.add((Float)Tc[M.t(self)].x);
      temp.add((Float)Tc[M.t(self)].y);
      temp.add((Float)Tc[M.t(opp)].x);
      temp.add((Float)Tc[M.t(opp)].y);
      MAT.add(temp);
      //line(Tc[M.t(self)].x, Tc[M.t(self)].y, Tc[M.t(opp)].x, Tc[M.t(opp)].y);
    }
  }
}

class Polyloop {             // class of polyloops (closed loop polygon)
  int vn = 6, cap=5000;      // number of control vertices and the cap on vn
  pt2D[] P = new pt2D [cap];     // control points
  vec2D[] L = new vec2D [cap];     // adjustment vectors for smoothing

  // CONSRTUCT, COPY FROM
  Polyloop () {vn=0; for (int i=0; i<cap; i++) P[i]=P2D();  for (int i=0; i<cap; i++) L[i]=V2D(); }    // makes points and vectors
  public void reset (int pvn) {vn=pvn; for (int i=0; i<vn; i++) {P[i].setTo(-sin((i+0.5f)*TWO_PI/vn)*(height*0.40f)+height/2.0f,cos((i+0.5f)*TWO_PI/vn)*(height*0.40f)+height/2.0f);}; }
  public void from(int pvn, pt2D [] Q)  {vn=pvn; for (int i=0; i<vn; i++) P[i].setTo(Q[i]);  };
  public void empty()  { vn=0; };
  public void appendPt(pt2D Q)  { P[vn++].setTo(Q);  };                                      // add point at end of list
  public void setTo(Polyloop Q) {vn=Q.vn; for (int i=0; i<vn; i++) P[i].setTo(Q.P[i]);};
  public void extendToMouse() {if(d2D(P[vn],Mouse2D())>5) P[vn++].setTo(Mouse2D()); }            // appends a point

  // ACCESS POINTS and LOOPING INDICES
  public pt2D rP(int i) {return P[i];}      // returns  P[i] (so that the caller chan change it!!!
  public pt2D cP(int i) {return P2D(P[i]);}  // returns a (safe) copy of P[i]
  public int n(int j) {  if (j==vn-1) {return (0);}  else {return(j+1);}  };  // n vertex in loop
  public int p(int j) {  if (j==0) {return (vn-1);}  else {return(j-1);}  };  // pious vertex in loop                                                     
  public pt2D pickPoint() {pt2D Q = P[0];  float dist = P[0].disToMouse();
    for(int i = 0; i < P.length; i++) if(P[i].disToMouse() < dist) {Q = P[i]; dist = P[i].disToMouse(); };
    if (dist>width/10) Q=null; return Q; }
  // DISPLAY 
  public void drawVertices() {beginShape(POINTS); for (int i=0; i<vn; i++) P[i].v();  endShape(); };  // draws vertices as dots
  public void showVertices() {for (int i=0; i<vn; i++) P[i].show(4);   };                             // draws vertices as circles that may be filled
  public void drawVertexIDs() {for (int i=0; i<vn; i++) {vec2D V=S2D(-10,U2D(proVec2D(P[p(i)],P[i],P[n(i)]))); V.add(-3,5); P[i].showLabel(str(i),V); };}; 
  public void drawCurve() {beginShape();  for (int i=0; i<vn; i++) P[i].v(); endShape(CLOSE); } 
  public void drawOpen() {beginShape();  for (int i=0; i<vn; i++) P[i].v(); endShape(); } 
  public void drawBezierSpans() {for (int i=0; i<vn; i++) drawBezier(i);}
  public void drawBezier(int i) {drawCubicBezier2D(P[i], T2D(P[i],1.f/6,V2D(P[p(i)],P[n(i)])), T2D(P[n(i)],-1.f/6,V2D(P[i],P[n(n(i))])), P[n(i)]); }
//  void drawSmooth(float s) {Polyloop Q = new Polyloop(); Q.refine(0); Q.drawCurve();} 
  public void drawSmooth(float s, int r) { // renders a refined version of P, s is the J-spline parameter, r is the number of refinements
     Polyloop Q = new Polyloop(); Q.setTo(this); for(int i=0; i<r; i++) Q.refine(0); Q.drawCurve(); } 
  public void showMouseProjection(float s, int r) {Polyloop Q = new Polyloop(); Q.setTo(this); for(int i=0; i<r; i++) Q.refine(0); 
    if(Q.contains(Mouse2D())) fill(green); else fill(magenta); Q.project(Mouse2D()).show(3); noFill();}
  
 // ARCHIVAL ON FILE
  public void savePts() {savePts(0);}
  public void loadPts() {loadPts(0);}
  public void savePts(int n) { String [] inppts = new String [vn+1];
    int s=0; inppts[s++]=str(vn); for (int i=0; i<vn; i++) {inppts[s++]=str(P[i].x)+","+str(P[i].y);};
    saveStrings("C"+Format0(n,2)+".pts",inppts);  };
  public void loadPts(int n) {String fn="data/C"+Format0(n,2)+".pts"; String [] ss = loadStrings(fn);
    String subpts;
    int s=0; int comma; vn = PApplet.parseInt(ss[s]);
    for(int i=0;i<vn; i++) { comma=ss[++s].indexOf(',');
      P[i]=new pt2D (PApplet.parseFloat(ss[s].substring(0, comma)), PApplet.parseFloat(ss[s].substring(comma+1, ss[s].length()))); }; };

  // RESAMPLE
  public float length () {float L=0; for (int i=0; i<vn; i++) L+=P[i].disTo(P[n(i)]); return(L); }
  public void resample(int n) {Polyloop Q = new Polyloop(); Q.resampledFrom(this,n); this.setTo(Q);}
  public void resampledFrom(Polyloop C, int nrv) {  
    float L = C.length();                            
    float d = L / nrv;                             
    float rd=d;  // remaining distance to n sample
    float cl=0;  // length of remaining portion of current edge
    int k=0,nk=0;
    pt2D Q = new pt2D(0,0);
     vn=0;
     Q.setTo(C.P[k]);            
     P[vn++].setTo(Q);      
     while (vn<nrv)  {
       nk=C.n(k); 
       cl=Q.disTo(C.P[nk]);                            
       if (rd<cl) {Q.translateTowardsBy(rd,C.P[nk]);
                   P[vn++].setTo(Q); cl-=rd; rd=d; }
              else {rd-=cl; Q.setTo(C.P[nk]); k++;     };
     };
   }
     
  public void translateTowards(float s, Polyloop Q)  {if (Q.vn>=vn) for (int i=0; i<vn; i++) P[i].translateTowards(s,Q.P[i]);  }; // blend towards Q by ratio s

  // SMOOTHEN (FILTER)
  public void smoothen(int n) {for (int i=0; i<n; i++) smoothen();}
  public void smoothen() {computeL(); applyL(0.3f); computeL(); applyL(-0.3f);}
  public void computeL() {for (int i=0; i<vn; i++) L[i]=vecToCubic2D(P[p(p(i))],P[p(i)],P[i],P[n(i)],P[n(n(i))]);};
  public void applyL(float s) {for (int i=0; i<vn; i++) P[i].translateBy(s,L[i]);};
  //void applyLhere(float roi) {for (int i=0; i<vn; i++) if (P[i].disToMouse()<roi) P[i].translateBy(0.5,L[i]);};
  //void showL() {for (int i=0; i<vn; i++) L[i].showAt(P[i]); }; 
 
  // REFINE (SUBDIVIDE)
  public void refine(float s) {refine(s,s);}
  public void refine(float a, float b) { 
      pt2D[] Q = new pt2D [2*vn];     
      for (int i=0; i<vn; i++) { Q[2*i]= B2D(P[p(i)],P[i],P[n(i)],a); Q[2*i+1]=F2D(P[p(i)],P[i],P[n(i)],P[n(n(i))],b); };
      vn*=2; for (int i=0; i<vn; i++) P[i].setTo(Q[i]);
     }
     
  // POINT / POLYLOOP DISTANCE, PROJECTION, INCLUSION   
   public pt2D project(pt2D M) {
     int v=0; for (int i=1; i<vn; i++) if (M.disTo(P[i])<M.disTo(P[v])) v=i; // compute index v to closest vertex
     int e=-1;
     float d = M.disTo(P[v]);
     for (int i=0; i<vn; i++) if ( M.projectsBetween(P[i],P[n(i)])  && (M.disToLine(P[i],P[n(i)])<d)) {e=i; d=M.disToLine(P[e],P[n(e)]);};
     if (e!=-1) return(M.makeProjectionOnLine(P[e],P[n(e)])); else return(P[v].makeClone());
     }
  public float distance(pt2D M) {return(M.disTo(project(M)));}
  public boolean contains (pt2D M) {boolean isIn=false; for (int i=1; i<vn-1; i++) if (M.isInTriangle(P[0],P[i],P[n(i)])) isIn=!isIn; return(isIn); }

  // GLOBAL TRANSFORMATIONS 
  public void frame() {
     float sx=height; float sy=height; float bx=0.0f; float by=0.0f; 
     for (int i=0; i<vn; i++) {if (P[i].x>bx) {bx=P[i].x;}; if (P[i].x<sx) {sx=P[i].x;}; if (P[i].y>by) {by=P[i].y;}; if (P[i].y<sy) {sy=P[i].y;}; };
     float m=max(bx-sx,by-sy);  float dx=(m-(bx-sx))/2; float dy=(m-(by-sy))/2; 
     for (int i=0; i<vn; i++) {P[i].x=(P[i].x-sx+dx)*4*height/5/m+height/10;  P[i].y=(P[i].y-sy+dy)*4*height/5/m+height/10;};    }   
  public void scaleWithMouse() {float s = scaleTracedWithMouse2D(); for (int i=0; i<vn; i++) P[i].setTo(L2D(screenCenter2D(),s,P[i]));};   
  public void translateWithMouse() {vec2D V=MouseDrag2D(); for (int i=0; i<vn; i++) P[i].translateBy(V); };   
  public void rotateWithMouse() {float a=angleTracedWithMouse2D(); for (int i=0; i<vn; i++) P[i].rotateBy(a,screenCenter2D());}; 
  } // end of Polyloop class

  static public void main(String args[]) {     PApplet.main(new String[] { "main" });  }}