void scribe(String S) {fill(black); text(S,20,20); noFill();}
void scribe(String S, int i) {fill(black); text(S,20,20+i*20); noFill();}
void scribe(String S, int i, int j) {fill(black); text(S,width-10*j,20+i*20); noFill();}

void keys() { 
  if (key==' ') { if (meshMode) showHelpText = true; showHelpText=!showHelpText;} 
  if (key=='?') printIt = !printIt;  // toggle debug mode
  //if  (47<int(key)) if (int(key)<56)  { int n=int(key)-48; mySelected(n);}    
  if(key=='a') spinAnimation = !spinAnimation;//animate=!animate;     
//  if(key=='c') myCopy();  
  if(key=='E') myDenoise();  
  if(key=='T') showEkey=!showEkey; 
//  if(key=='k') showKeys=!showKeys;  
//  if(key=='w') myTranslate();  // executed in my actions for faster response
//  if(key=='n') showMouseProjection=!showMouseProjection;
//  if(key=='p') myPaste();  
  if(key=='f') myRefine();  
  if(key=='A') mySample();  
//  if(key=='e') myRotate();  // executed in my actions for faster response
  if(key=='v') showVertices=!showVertices;  // toggle showing control vertices
  if(key=='<') { vc /= 2; if (vc < 3) vc = 3; for (int i = 0; i < kc; i++) CP[i].resample(vc); }
  if(key=='>') { vc *= 2; for (int i = 0; i < kc; i++) CP[i].resample(vc); }
  if(key==',') { sprayNum /= 2; if (sprayNum < 1) sprayNum = 1; }
  if(key=='.') { sprayNum *= 2; }
//  if(key=='z') myScale();  // executed in my actions for faster response
  if(key=='b') {loopToMesh(); bulge();}
  if(key=='h') mat = !mat;
  if(key=='H') matDisks = !matDisks;
  if(key=='S') M.laplace2D(1.0/3.0);
  if(key=='M') {meshMode = !meshMode; if (!meshMode && M.g().z < 0) M.c = O2D[M.c]; if (meshMode) showHelpText = false;}
  if (key=='I') {M.computeIsolation();}
  if (key=='D') {M.showDistance=!M.showDistance; if(M.showDistance) {M.computeDistance(maxr); println("showing distance");} else println("not showing distance");};
  if (key=='q') {C.setMark(); M.hitTriangle();/* C.F.setToPoint(mark); C.pullE(); C.pose(); */ M.writeCorner();}
  if (key=='[') {maxr--; if (maxr<1) maxr=1; M.computeDistance(maxr);};
  if (key==']') {maxr++; M.computeDistance(maxr);}
  if (key=='0') {maxr=0; M.computeDistance(maxr);}
  if (key=='P') {M.computePath(); M.showDistance=true; println("showing path"); println("not showing path"); };
  if (key=='N') {M.showNormals=!M.showNormals; if(M.showNormals) {M.normals(); println("showing normals");} else println("not showing normals"); }
  if (key=='n') M.c = M.n();
  if (key=='p') M.c = M.p();
  if (key=='o') M.c = M.o();
  if (key=='l') M.c = M.l();
  if (key=='r') M.c = M.r();
  if (key=='s') M.c = M.s();
  if (key=='m') mirror();
  if (key=='y') {coolSpray = !coolSpray; loopToMesh(); bulge();}
  if (key=='u') {matMin = true; matAverage = false; matMax = false; loopToMesh(); bulge();}
  if (key=='j') {matMin = false; matAverage = true; matMax = false; loopToMesh(); bulge();}
  if (key=='i') {matMin = false; matAverage = false; matMax = true; loopToMesh(); bulge();}

  if (key=='L') {myLoad(); mySelected(0);}
//  if (key=='R') myReset();
  if (key=='W') mySave(); 
  if (key=='X') picture(); 
  };     

void updateView() {
  //if (keyCode==SHIFT) {C.Pan(); C.pullE(); };
  //if (keyCode==CONTROL) {C.turn(); C.pullE(); };  
  if (key=='z') {C.pose(); C.zoom(); C.pullE(); };
  // if (key=='1') {C.pose(); C.fly(1.0); C.pullE(); };  
  // if (key=='2') {C.pose(); C.Pan(); C.pullE(); };
  // if (key=='3') {C.pose(); C.fly(-1.0); C.pullE();  };
  // if (key=='v') {C.pose(); C.Turn(); C.pullE(); };
  // if (key=='5') {C.pan(); C.pullE(); }; 
  // if (key=='w') {M.moveROI();}; 
  // if (key=='m') {M.move();}; 
  }

void showHelp() {
    fill(dblue); pushMatrix(); translate(20,20);
     text("Polyloop and Mesh Manipulation by Michael Cook, Derek Tatum, and Patrick Jahn",0,0); translate(0,20);               // **P04
     text("  ",0,0); translate(0,20);
     text("First click in the window to activate it ",0,0); translate(0,20);
     text("Press SPACE to show/hide this help text",0,0); translate(0,20);
     text("  ",0,0); translate(0,20);
     text("While in Polyloop View",0,0); translate(0,20);
     text("  ",0,0); translate(0,20);
     text("Hold and drag to:",0,0); translate(0,20);
     text(" 'w':translate, 'z':scale, 'e':rotate, 'f':refine, 'A':resample, 'E':denoise.",0,0); translate(0,20);
     text("  ",0,0); translate(0,20);
     text("You can also use '<' and '>' to half or double the number of control vertices",0,0); translate(0,20);
     text("Or ',' and '.' to half/double the number of spray points. Use 'y' to toggle the spray mode",0,0); translate(0,20);
     text("  ",0,0); translate(0,20);
     text("Use 'S' to Laplace smooth and 'b' to perform the bulge. Then press 'M' to convert to Mesh View.",0,0); translate(0,20);
     text("Use 'u', 'j', and 'i' to use the min, average, or max (respectively) for bulge radius",0,0); translate(0,20);
     text("  ",0,0); translate(0,20);
     text("While in Mesh View",0,0); translate(0,20);
     text("",0,0); translate(0,20);
     text("Press 'm' to mirror the mesh, and 'N' to display the triangle and vertex normals.",0,0); translate(0,20);
     text("  ",0,0); translate(0,20);
     text("Press 'D' to shift to Distance Mode, then 'I' to turn on Isolation Measure. Use '[' and ']'",0,0); translate(0,20);
     text("to increment how many triangle units to travel. Hover and hit 'q' to pick two triangles",0,0); translate(0,20);
     text("and then 'P' to color in the shortest geodesic distance between the two triangles.",0,0); translate(0,20); 
     text("  ",0,0); translate(0,20);
     text("Use 'n','p','o','s','l','r' to perform those corner operations in Mesh or Polyloop View.",0,0); translate(0,20);
     text("  ",0,0); translate(0,20);
     text("Press 'a' to animate your mesh rotating around its y axis!",0,0); translate(0,20);
     popMatrix(); noFill();
   }
     
